package nc.ui.arap.actions;

import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileOutputStream;

import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.KeyStroke;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.sfbase.client.ClientToolKit;
import nc.ui.arap.view.ArapBillCardForm;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pubapp.uif2app.actions.BodyAddLineAction;

/**
 * 
 * @author YY
 *
 */
public class OutputBodyAction extends BodyAddLineAction{
	private static final long serialVersionUID = 3494691988068685023L;
	private ArapBillCardForm editorModel;
	private Icon icon = ClientToolKit.loadImageIcon("\\themeroot\\blue\\themeres\\ui\\toolbaricons\\cite_model_normal.png");
	private IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private Sheet sheet = null;
	public ArapBillCardForm getEditorModel() {
		return editorModel;
	}

	public void setEditorModel(ArapBillCardForm arapBillCardForm) {
		this.editorModel = arapBillCardForm;
	}
	
	public OutputBodyAction(){
		setCode("OutputBodyAction");
		setBtnName("");
		setName("");
		putValue("AcceleratorKey", KeyStroke.getKeyStroke(82, 8));
		setShowNameInToolbar(true);
		setIsShow(true);
		putValue("ShortDescription", "");
		putValue("SmallIcon", icon);

	}
	
	@Override
	public void doAction(ActionEvent e) throws Exception {
		//ֻӦĿ ӦĿʹ
		String type = sqlexecuteQuery("billtypename", "bd_billtype", "pk_billtypeid", this.editorModel.getBillCardPanel().getHeadItem("pk_tradetypeid").getValueObject().toString());		
		if(!"ӦĿ".equals(type) && !"ӦĿ".equals(type) && !"ԤĿ".equals(type) && !"ԤĿ".equals(type)) {
			return;
		}
		// ļѡ  
	    JFileChooser fileChooser = new JFileChooser();  
	    fileChooser.setDialogTitle("ѡ񵼳·");  
	    // ļѡģʽΪģʽԱûѡ񱣴ļ·  
	    fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY); // ֻʾļʾļ
	    // ļ
	    FileNameExtensionFilter filter = new FileNameExtensionFilter("Excelļ (*.xls)", "xls");
	    fileChooser.setFileFilter(filter);
	    // ļѡļ  
	    fileChooser.setSelectedFile(new File("MyFileName"));  
	    // ʾļ
	    fileChooser.setFileHidingEnabled(false); // صļʾ
	    // ʾļѡԻ򣬲ȴûѡ·  
	    int result = fileChooser.showSaveDialog(null);
	    // ûǷѡ·
	    if (result == JFileChooser.APPROVE_OPTION) {
	        // һµĹ
	        Workbook workbook = new HSSFWorkbook();
	        // һ
	        sheet = workbook.createSheet("Sheet1");
	        outputData(this, type);
	        // һµCellStyle  
			CellStyle cellStyle = workbook.createCellStyle();  
			// ӦµʽһеһеĵԪ  
			Cell firstCell = sheet.getRow(0).getCell(0);  
			sheet.getRow(0).setHeight((short)1500);
		    cellStyle.setWrapText(true); // ı
		    firstCell.setCellStyle(cellStyle);
	        // ļʹȷļ·
	        File selectedFile = fileChooser.getSelectedFile();
	        if (!selectedFile.getName().toLowerCase().endsWith(".xls")) {
	            selectedFile = new File(selectedFile.getParentFile(), selectedFile.getName() + ".xls");
	        }
	        FileOutputStream outputStream = new FileOutputStream(selectedFile);
	        workbook.write(outputStream);
	        outputStream.close();
	    } else {
	       return;
	    }
		
	}

	public void outputData(OutputBodyAction outputBodyAction, String type) throws Exception {
		sheet.addMergedRegion(new CellRangeAddress(0, 0, 0, 10));
		// к͵Ԫ  
		createRowAndCells(sheet, 0, "*֪:\n"
				+ "1.ͽݱΪıʽ;\n"
				+ "2.*ΪȷϺе;\n"
				+ "3.ĳнвʱ뽫ӦķƱŴ뵽УƱŲ޸ģ");
		BillCardPanel cp = outputBodyAction.editorModel.getBillCardPanel();
		
		int count = cp.getRowCount();
		if("ӦĿ".equals(type)) {
			//Ŀģ
			createRowAndCells(sheet, 1, "ժҪ*", "ù*", "Ԥ*","Ԥ*","Ʊ*","*","㷽ʽ*","˰*","˰*","","*","˰*","˰ϼ*","񺽷չ",
					"","ͻ","ͻ㼶","ԭƱyyyy-mm-dd hh:mm:ss","ע","Ա","ɱ*","*");  
			
			for (int i = 0; i < count; i++) {
				Row rows = sheet.createRow(i+2); 
				//ժҪ
		        rows.createCell(0).setCellValue(getBodyValueAt(cp, i, "def25", "name", "bd_defdoc", "pk_defdoc"));
		        //ù
		        rows.createCell(1).setCellValue(getBodyValueAt(cp, i, "def30", "name", "bd_defdoc", "pk_defdoc"));
		        //Ԥ
		        rows.createCell(2).setCellValue(cp.getBodyValueAt(i, "def1") == null ? null : cp.getBodyValueAt(i, "def1").toString());
		        //Ԥ
		        rows.createCell(3).setCellValue(getBodyValueAt(cp, i, "pk_subjcode", "name", "bd_inoutbusiclass", "pk_inoutbusiclass"));
		        //Ʊ
		        rows.createCell(4).setCellValue(cp.getBodyValueAt(i, "def12") == null ? null : cp.getBodyValueAt(i, "def12").toString());
		        //
		        rows.createCell(5).setCellValue(cp.getBodyValueAt(i, "quantity_cr") == null ? null : cp.getBodyValueAt(i, "quantity_cr").toString());
		        //㷽ʽ
		        rows.createCell(6).setCellValue(getBodyValueAt(cp, i, "pk_balatype", "name", "bd_balatype", "pk_balatype"));
		        //˰
		        rows.createCell(7).setCellValue(getBodyValueAt(cp, i, "taxcodeid", "description", "bd_taxcode", "pk_taxcode"));
		        //˰
		        rows.createCell(8).setCellValue(cp.getBodyValueAt(i, "taxrate") == null ? null : cp.getBodyValueAt(i, "taxrate").toString());
		        //
		        rows.createCell(9).setCellValue(cp.getBodyValueAt(i, "price") == null ? null : cp.getBodyValueAt(i, "price").toString());
		        //
		        rows.createCell(10).setCellValue(cp.getBodyValueAt(i, "local_notax_cr") == null ? null : cp.getBodyValueAt(i, "local_notax_cr").toString());
		        //˰
		        rows.createCell(11).setCellValue(cp.getBodyValueAt(i, "local_tax_cr") == null ? null : cp.getBodyValueAt(i, "local_tax_cr").toString());
		        //˰ϼ
		        rows.createCell(12).setCellValue(cp.getBodyValueAt(i, "local_money_cr") == null ? null : cp.getBodyValueAt(i, "local_money_cr").toString());
		        //񺽷չ
		        rows.createCell(13).setCellValue(cp.getBodyValueAt(i, "def29") == null ? null : cp.getBodyValueAt(i, "def29").toString());
		        //
		        rows.createCell(14).setCellValue(cp.getBodyValueAt(i, "def21") == null ? null : cp.getBodyValueAt(i, "def21").toString());
		        //ͻ
		        rows.createCell(15).setCellValue(getBodyValueAt(cp, i, "def13", "name", "bd_defdoc", "pk_defdoc"));
		        //ͻ㼶
		        rows.createCell(16).setCellValue(cp.getBodyValueAt(i, "def22") == null ? null : cp.getBodyValueAt(i, "def22").toString());
		        //ԭƱ
		        rows.createCell(17).setCellValue(cp.getBodyValueAt(i, "def17") == null ? null : cp.getBodyValueAt(i, "def17").toString());
		        //ע
		        rows.createCell(18).setCellValue(cp.getBodyValueAt(i, "def2") == null ? null : cp.getBodyValueAt(i, "def2").toString());
		        //Ա
		        rows.createCell(19).setCellValue(cp.getBodyValueAt(i, "def40") == null ? null : cp.getBodyValueAt(i, "def40").toString());
		        //ɱ
		        rows.createCell(20).setCellValue(getBodyValueAt(cp, i, "def23", "name", "org_dept", "pk_dept"));
		        //
		        rows.createCell(21).setCellValue(getBodyValueAt(cp, i, "material", "name", "bd_material", "pk_material"));
		        
			}
		}else if("ӦĿ".equals(type)){
			//Ŀģ
			createRowAndCells(sheet, 1, "ժҪ*", "ù*", "Ŀ*","Ŀ*","רҵ*","*","Ʊ*","*","˰*","˰*","㷽ʽ*","","*","˰*","񺽷չ",
					"˰ϼ*","","ɱ*","Ʊݺ/","ע","Ԥ*","*");  
			for (int i = 0; i < count; i++) {
				Row rows = sheet.createRow(i+2); 
				//ժҪ
		        rows.createCell(0).setCellValue(getBodyValueAt(cp, i, "def25", "name", "bd_defdoc", "pk_defdoc"));
		        //ù
		        rows.createCell(1).setCellValue(getBodyValueAt(cp, i, "def30", "name", "bd_defdoc", "pk_defdoc"));
		        //Ŀ
		        rows.createCell(2).setCellValue(cp.getBodyValueAt(i, "def18") == null ? null : cp.getBodyValueAt(i, "def18").toString());
		        //Ŀ
		        rows.createCell(3).setCellValue(getBodyValueAt(cp, i, "project", "project_name", "bd_project", "pk_project"));
			    //רҵ
		        rows.createCell(4).setCellValue(getBodyValueAt(cp, i, "def6", "name", "bd_defdoc", "pk_defdoc"));
		        //
		        rows.createCell(5).setCellValue(getBodyValueAt(cp, i, "def7", "name", "bd_defdoc", "pk_defdoc"));
		        //Ʊ
		        rows.createCell(6).setCellValue(cp.getBodyValueAt(i, "def12") == null ? null : cp.getBodyValueAt(i, "def12").toString());
		        //
		        rows.createCell(7).setCellValue(cp.getBodyValueAt(i, "quantity_cr") == null ? null : cp.getBodyValueAt(i, "quantity_cr").toString());
		        //˰
		        rows.createCell(8).setCellValue(getBodyValueAt(cp, i, "taxcodeid", "description", "bd_taxcode", "pk_taxcode"));
		        //˰
		        rows.createCell(9).setCellValue(cp.getBodyValueAt(i, "taxrate") == null ? null : cp.getBodyValueAt(i, "taxrate").toString());
		        //㷽ʽ
		        rows.createCell(10).setCellValue(getBodyValueAt(cp, i, "pk_balatype", "name", "bd_balatype", "pk_balatype"));
		        //
		        rows.createCell(11).setCellValue(cp.getBodyValueAt(i, "price") == null ? null : cp.getBodyValueAt(i, "price").toString());
		        //
		        rows.createCell(12).setCellValue(cp.getBodyValueAt(i, "local_notax_cr") == null ? null : cp.getBodyValueAt(i, "local_notax_cr").toString());
		        //˰
		        rows.createCell(13).setCellValue(cp.getBodyValueAt(i, "local_tax_cr") == null ? null : cp.getBodyValueAt(i, "local_tax_cr").toString());
		        //񺽷չ
		        rows.createCell(14).setCellValue(cp.getBodyValueAt(i, "def29") == null ? null : cp.getBodyValueAt(i, "def29").toString());
		        //˰ϼ
		        rows.createCell(15).setCellValue(cp.getBodyValueAt(i, "local_money_cr") == null ? null : cp.getBodyValueAt(i, "local_money_cr").toString());
		        //
		        rows.createCell(16).setCellValue(cp.getBodyValueAt(i, "def21") == null ? null : cp.getBodyValueAt(i, "def21").toString());
		        //ɱ
		        rows.createCell(17).setCellValue(getBodyValueAt(cp, i, "def22", "name", "org_dept", "pk_dept"));
		        //Ʊݺ/
		        rows.createCell(18).setCellValue(cp.getBodyValueAt(i, "def5") == null ? null : cp.getBodyValueAt(i, "def5").toString());
		        //ע
		        rows.createCell(19).setCellValue(cp.getBodyValueAt(i, "def2") == null ? null : cp.getBodyValueAt(i, "def2").toString());
		        //Ԥ
		        rows.createCell(20).setCellValue(getBodyValueAt(cp, i, "pk_subjcode", "name", "bd_inoutbusiclass", "pk_inoutbusiclass"));
		        //
		        rows.createCell(21).setCellValue(getBodyValueAt(cp, i, "material", "name", "bd_material", "pk_material"));
			}
		}else if("ԤĿ".equals(type)){
			//Ŀģ
			createRowAndCells(sheet,1,"ժҪ*","ù*","Ԥ*","Ԥ*","Ʊ*","*","˰*","˰*","","*","˰*","˰ϼ*","˰*",
					"ɱ*","*","ע","Էλ*","*","Ӧ*");
			for (int i = 0; i < count; i++) {
				Row rows = sheet.createRow(i+2);
				//ժҪ
		        rows.createCell(0).setCellValue(getBodyValueAt(cp, i, "def25", "name", "bd_defdoc", "pk_defdoc"));
		        //ù
		        rows.createCell(1).setCellValue(getBodyValueAt(cp, i, "def30", "name", "bd_defdoc", "pk_defdoc"));
		        //Ԥ
		        rows.createCell(2).setCellValue(cp.getBodyValueAt(i, "def1") == null ? null : cp.getBodyValueAt(i, "def1").toString());
		        //Ԥ
		        rows.createCell(3).setCellValue(getBodyValueAt(cp, i, "pk_subjcode", "name", "bd_inoutbusiclass", "pk_inoutbusiclass"));
		        //Ʊ
		        rows.createCell(4).setCellValue(cp.getBodyValueAt(i, "def12") == null ? null : cp.getBodyValueAt(i, "def12").toString());
		        //
		        rows.createCell(5).setCellValue(getBodyValueAt(cp, i, "material", "name", "bd_material", "pk_material"));
		        //˰
		        rows.createCell(6).setCellValue(getBodyValueAt(cp, i, "taxcodeid", "description", "bd_taxcode", "pk_taxcode"));
		        //˰
		        rows.createCell(7).setCellValue(cp.getBodyValueAt(i, "taxrate") == null ? null : cp.getBodyValueAt(i, "taxrate").toString());
		        //
		        rows.createCell(8).setCellValue(cp.getBodyValueAt(i, "price") == null ? null : cp.getBodyValueAt(i, "price").toString());
		        //
		        rows.createCell(9).setCellValue(cp.getBodyValueAt(i, "local_notax_cr") == null ? null : cp.getBodyValueAt(i, "local_notax_cr").toString());
		        //˰
		        rows.createCell(10).setCellValue(cp.getBodyValueAt(i, "local_tax_cr") == null ? null : cp.getBodyValueAt(i, "local_tax_cr").toString());
		        //˰ϼ
		        rows.createCell(11).setCellValue(cp.getBodyValueAt(i, "local_money_cr") == null ? null : cp.getBodyValueAt(i, "local_money_cr").toString());
		        //˰
		        rows.createCell(12).setCellValue("0".equals(cp.getBodyValueAt(i, "taxtype").toString()) ? "Ӧ˰ں" : "Ӧ˰");
		        //ɱ
		        rows.createCell(13).setCellValue(getBodyValueAt(cp, i, "def23", "name", "org_dept", "pk_dept"));
		        //
		        int objtype = (Integer) (cp.getBodyValueAt(i, "objtype")  == null ? -1 : cp.getBodyValueAt(i, "objtype"));
		        rows.createCell(14).setCellValue(objtype == 1 ? "Ӧ" : objtype == 2 ? "" : objtype == 3 ? "ҵԱ" : null);
		        //ע
		        rows.createCell(15).setCellValue(cp.getBodyValueAt(i, "def2") == null ? null : cp.getBodyValueAt(i, "def2").toString());
		        //Էλ
		        rows.createCell(16).setCellValue(getBodyValueAt(cp, i, "supplier", "name", "bd_supplier", "pk_supplier"));
		        //
		        rows.createCell(17).setCellValue(getBodyValueAt(cp, i, "pk_deptid", "name", "org_dept", "pk_dept"));
		        //Ӧ
		        rows.createCell(18).setCellValue(getBodyValueAt(cp, i, "pk_tradetypeid", "billtypename", "bd_billtype", "pk_billtypeid"));
		        
			}
		}else {
			//Ŀģ
			createRowAndCells(sheet,1,"ժҪ*","ù*","Ŀ*","Ŀ*","רҵ*","*","Ʊ*","*","˰*","˰*","","*","˰*",
					"˰ϼ*","ɱ*","˰*","*","Էλ*","ע","Ԥ*","Ӧ*");  
			for (int i = 0; i < count; i++) {
				Row rows = sheet.createRow(i+2);
				//ժҪ
		        rows.createCell(0).setCellValue(getBodyValueAt(cp, i, "def25", "name", "bd_defdoc", "pk_defdoc"));
		        //ù
		        rows.createCell(1).setCellValue(getBodyValueAt(cp, i, "def30", "name", "bd_defdoc", "pk_defdoc"));
		        //Ŀ
		        rows.createCell(2).setCellValue(cp.getBodyValueAt(i, "def18") == null ? null : cp.getBodyValueAt(i, "def18").toString());
		        //Ŀ
		        rows.createCell(3).setCellValue(getBodyValueAt(cp, i, "project", "project_name", "bd_project", "pk_project"));
		        //רҵ
		        rows.createCell(4).setCellValue(getBodyValueAt(cp, i, "def6", "name", "bd_defdoc", "pk_defdoc"));
		        //
		        rows.createCell(5).setCellValue(getBodyValueAt(cp, i, "def7", "name", "bd_defdoc", "pk_defdoc"));
		        //Ʊ
		        rows.createCell(6).setCellValue(cp.getBodyValueAt(i, "def12") == null ? null : cp.getBodyValueAt(i, "def12").toString());
		        //
		        rows.createCell(7).setCellValue(getBodyValueAt(cp, i, "material", "name", "bd_material", "pk_material"));
		        //˰
		        rows.createCell(8).setCellValue(getBodyValueAt(cp, i, "taxcodeid", "description", "bd_taxcode", "pk_taxcode"));
		        //˰
		        rows.createCell(9).setCellValue(cp.getBodyValueAt(i, "taxrate") == null ? null : cp.getBodyValueAt(i, "taxrate").toString());
		        //
		        rows.createCell(10).setCellValue(cp.getBodyValueAt(i, "price") == null ? null : cp.getBodyValueAt(i, "price").toString());
		         //
		        rows.createCell(11).setCellValue(cp.getBodyValueAt(i, "local_notax_cr") == null ? null : cp.getBodyValueAt(i, "local_notax_cr").toString());
		        //˰
		        rows.createCell(12).setCellValue(cp.getBodyValueAt(i, "local_tax_cr") == null ? null : cp.getBodyValueAt(i, "local_tax_cr").toString());
		        //˰ϼ
		        rows.createCell(13).setCellValue(cp.getBodyValueAt(i, "local_money_cr") == null ? null : cp.getBodyValueAt(i, "local_money_cr").toString());
		        //ɱ
		        rows.createCell(14).setCellValue(getBodyValueAt(cp, i, "def22", "name", "org_dept", "pk_dept"));
		        //˰
		        rows.createCell(15).setCellValue("0".equals(cp.getBodyValueAt(i, "taxtype").toString()) ? "Ӧ˰ں" : "Ӧ˰");
		        //
		        int objtype = (Integer) (cp.getBodyValueAt(i, "objtype")  == null ? -1 : cp.getBodyValueAt(i, "objtype"));
		        rows.createCell(16).setCellValue(objtype == 1 ? "Ӧ" : objtype == 2 ? "" : objtype == 3 ? "ҵԱ" : null);
		        //Էλ
		        rows.createCell(17).setCellValue(getBodyValueAt(cp, i, "supplier", "name", "bd_supplier", "pk_supplier"));
		        //ע
		        rows.createCell(18).setCellValue(cp.getBodyValueAt(i, "def2") == null ? null : cp.getBodyValueAt(i, "def2").toString());
		        //Ԥ
		        rows.createCell(19).setCellValue(getBodyValueAt(cp, i, "pk_subjcode", "name", "bd_inoutbusiclass", "pk_inoutbusiclass"));
		        //Ӧ
		        rows.createCell(20).setCellValue(getBodyValueAt(cp, i, "pk_tradetypeid", "billtypename", "bd_billtype", "pk_billtypeid"));
			}
		}
	}

	// к͵Ԫķ  
	private void createRowAndCells(Sheet sheet, int rowIndex, String... cellValues) {  
	    Row row = sheet.createRow(rowIndex);  
	    for (int i = 0; i < cellValues.length; i++) {  
	        row.createCell(i).setCellValue(cellValues[i]);  
	        
	    }  
	}  
	
	// ȡݵķ  
	private String getBodyValueAt(BillCardPanel cp, int rowIndex, String columnName, String out, String table, String key) throws Exception {  
	    return cp.getBodyValueAt(rowIndex, columnName) == null ? null : sqlexecuteQuery(out, table, key, (String)cp.getBodyValueAt(rowIndex, columnName));  
	}  
	
	/*
	 * ݿѯ
	 */
	private String sqlexecuteQuery(String out,String table,String key,String value) throws Exception {
		
		String sql = "select "+out+" from "+table+" where "+key+" = '"+value+"'";
		
		Object object;
			object = iuap.executeQuery(sql, new ColumnProcessor());
			if (object == null) {
				return null;
			}
			return object.toString();
	}
}
