package nc.ui.hr.baod_orders.view;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import nc.bs.framework.common.NCLocator;
import nc.desktop.ui.WorkbenchEnvironment;
import nc.itf.hr.SocialInsuranceAllMaintain;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.vo.ecpubapp.pattern.data.ValueUtils;
import nc.vo.uap.rbac.profile.FunctionPermProfileManager;

/**
 * ˣʵʼ˾ѽɵ¹ʸ˲ѿҳ
 * @author YaoYu
 *
 */
public class AccumulationFundAllInsertDiaLog extends UIDialog implements ActionListener,BillEditListener{

	private static final long serialVersionUID = 1L;
	private SocialInsuranceAllMaintain siaMaintain = NCLocator.getInstance().lookup(SocialInsuranceAllMaintain.class);
	private IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private UIPanel btnUIPanel;
	private BillCardPanel jlcardPanel = null;//
	private UIButton btnOK;
	private UIButton btnAddRow;
	private UIButton btnRemoveRow;
	private UIPanel ivjUIPanel = null;
	
	@SuppressWarnings("deprecation")
	public AccumulationFundAllInsertDiaLog() throws Exception {
		initialize();
	}
	
	private void initialize() {
	    setLayout(new BorderLayout());
	    setSize(new Dimension(1050, 350));
	    this.setResizable(true);
	    add(getUIPanel(), BorderLayout.CENTER);
	    this.addListenerEvent();
	    doAddAction();
	}
	
	
	private UIPanel getUIPanel() {
		if (this.ivjUIPanel == null) {
			this.ivjUIPanel = new UIPanel();
			this.ivjUIPanel.setLayout(new BorderLayout());
			this.ivjUIPanel.setPreferredSize(new Dimension(0, 500));
			this.ivjUIPanel.add(getBtnUIPanel(), BorderLayout.SOUTH);
			this.ivjUIPanel.add(getJlcardPanel(), BorderLayout.CENTER);
		}
		return this.ivjUIPanel;
	}	

	private void addListenerEvent() {
		this.getJlcardPanel().addEditListener(this);
		this.getBtnOK().addActionListener(this);
		this.getBtnAddRow().addActionListener(this);
		this.getBtnRemoveRowRow().addActionListener(this);
	}
	
	
	
	private BillCardPanel getJlcardPanel() {
		if(this.jlcardPanel == null){
			this.jlcardPanel = new BillCardPanel();
			this.jlcardPanel.setName("jlcardPanel");
			//ݵģģ
			this.jlcardPanel.loadTemplet("gjjft",null,WorkbenchEnvironment.getInstance().getLoginUser().getPrimaryKey(),
					WorkbenchEnvironment.getInstance().getLoginUser().getPk_org());
			UIRefPane orgCodeRef = (UIRefPane) this.jlcardPanel.getBodyItem("orgcode").getComponent();
			UIRefPane orgCodeRefs = (UIRefPane) this.jlcardPanel.getBodyItem("contributoryorg").getComponent();
			//ڵ
			String nodeCode = "60H20104";
			//Ȩ֯
			String[] pkorgs = FunctionPermProfileManager.getInstance().getProfile(WorkbenchEnvironment.getInstance().getLoginUser().getUser_code()).getFuncSubInfo(nodeCode).getFuncPermissionPkorgs();
			//˾ֶ֯Ȩ
			orgCodeRef.getRefModel().setFilterPks(pkorgs);
			//ɱ˾֯Ȩ
			orgCodeRefs.getRefModel().setFilterPks(pkorgs);
		}
		return this.jlcardPanel;
	}

	private UIPanel getBtnUIPanel() {
		if (this.btnUIPanel == null) {
			this.btnUIPanel = new nc.ui.pub.beans.UIPanel();
			//btnUIPanel.add(this.getBtnAddRow(), this.getBtnAddRow().getName());
			//btnUIPanel.add(this.getBtnRemoveRowRow(), this.getBtnRemoveRowRow().getName());
			this.btnUIPanel.add(this.getBtnOK(), this.getBtnOK().getName());
		}
		return this.btnUIPanel;
	}
	
	private UIButton getBtnAddRow() {
	    if (this.btnAddRow == null) {
	    	this.btnAddRow = new UIButton();
	        this.btnAddRow.setName("btnAddRow");
	        this.btnAddRow.setText("");
	    }
	    return this.btnAddRow;
	}
	
	private UIButton getBtnRemoveRowRow() {
	    if (this.btnRemoveRow == null) {
	    	this.btnRemoveRow = new UIButton();
	    	this.btnRemoveRow.setName("btnRemoveRow");
	    	this.btnRemoveRow.setText("ɾ");
	    }
	    return this.btnRemoveRow;
	}


	private UIButton getBtnOK() {
		if (this.btnOK == null) {
			this.btnOK = new UIButton();
			this.btnOK.setName("btnOK");
			this.btnOK.setText("ȷ(Y)");
		}
		return this.btnOK;
	}

	private void doOKAction() {
		try {
			BillCardPanel cp = this.jlcardPanel;
			//жϱ
			this.jlcardPanel.dataNotNullValidate();	

			//ѭ
			for (int i = 0; i < cp.getRowCount(); i++) {
				String tableName = ValueUtils.getString(cp.getBodyValueAt(i, "tablename"));//
				String orgCode = QueyrOrgCode(ValueUtils.getString(cp.getBodyValueAt(i, "orgcode")));//˾
				String contributoryOrgName = ValueUtils.getString(cp.getBodyValueAt(i, "contributoryorg"));//ɱ˾
				String period = ValueUtils.getString(cp.getBodyValueAt(i, "period"));//
				String clerkCode = ValueUtils.getString(cp.getBodyValueAt(i, "clerkcode"));//Ա
				String clerkName = ValueUtils.getString(cp.getBodyValueAt(i, "clerkname"));//
				String basicssum = ValueUtils.getString(cp.getBodyValueAt(i, "basicssum"));//ɻ
				String staffsum = ValueUtils.getString(cp.getBodyValueAt(i, "staffsum"));//˲
				String orgsum = ValueUtils.getString(cp.getBodyValueAt(i, "orgsum"));//˾
				String mark = ValueUtils.getString(cp.getBodyValueAt(i, "mark"));//ע
				//contributoryOrgNameܴΪյ,ƴӵʱnullƴӵµַʹĿ㴦
				contributoryOrgName = contributoryOrgName == null ? "" : contributoryOrgName;
				String combinedField = tableName + contributoryOrgName + clerkCode + clerkName;
				if(queryTable(orgCode, period, combinedField)) {
					MessageDialog.showHintDlg(this, "ʾ", "ɱ˾:" +contributoryOrgName+ ",Աţ" + clerkCode + "Ѵڲ");
				return;
				}
				StringBuilder insertSQL = new StringBuilder("INSERT INTO accumulation_fund VALUES (");
				insertSQL.append("'").append("̯").append("', ");
				insertSQL.append("'").append(orgCode).append("', ");
				insertSQL.append("'").append(period).append("', ");
				insertSQL.append("'").append(combinedField).append("', ");
				insertSQL.append(getString(contributoryOrgName)).append(", ");
				insertSQL.append(getString(clerkCode)).append(", ");
				insertSQL.append(getString(clerkName)).append(", ");
				insertSQL.append(getString(basicssum)).append(", ");
				insertSQL.append(getString(staffsum)).append(", ");
				insertSQL.append(getString(orgsum)).append(", ");
				insertSQL.append(getString(mark)).append(", ");
				insertSQL.append("sysdate,");
				insertSQL.append("null)");
				siaMaintain.executeBaseDAO(insertSQL.toString());
			}
			//رյ
			this.dispose();
		} catch (Exception e) {
			MessageDialog.showHintDlg(this, "ʾ", e.getMessage());
		}
	}

	
	/**
	 *һвһ
	 */
	private void doAddAction() {
		 this.jlcardPanel.getBillModel().addLine();
	}
	
	/**
	 * ɾһ
	 */
	private void doRemoveAction() {
		this.jlcardPanel.delLine();
	}
	
	
	@Override
	public void afterEdit(BillEditEvent arg0) {
		
	}

	@Override
	public void bodyRowChange(BillEditEvent arg0) {
		
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.getBtnOK()) {
			// ȷťִ¼
			this.doOKAction();
		}else if (e.getSource() == this.getBtnAddRow()) {
			// аťִ¼
			this.doAddAction();
		}else {
			// ɾаťִ¼
			this.doRemoveAction();
		}	
	}
	
	/**
	 * Objectתsqlƴַ
	 * @param value
	 * @return
	 */
	private String getString(Object value) {
		if("".equals(value) || value == null) {
			return null;
		}
		return "'"+value+"'";
		
	}
	
	/**
	 * ѯмǷ
	 * @param orgCode ѯ֯
	 * @param period ѯڼ
	 * @param combinedField С+С֯+Ա+
	 * @return
	 * @throws Exception
	 */
	private Boolean queryTable(String orgCode, String period,String combinedField) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" combined_field,basicssum,staffsum,orgsum,mark from accumulation_fund");
		sql.append(" WHERE ");
		sql.append(" tablename = '̯' AND combined_field = '" + combinedField + "'");
		sql.append(" AND orgcode = '" + orgCode + "' AND period = '" + period + "' ");
		if (iuap.executeQuery(sql.toString(), new ColumnProcessor()) == null) {
			return false;
		} else {
			return true;
		}
	}
	
	/**
	 * ֯Ʋѯ֯
	 * @param orgName
	 * @return
	 * @throws Exception
	 */
	public String QueyrOrgCode(String orgName) throws Exception {
		String sql = "select code from org_financeorg where name ='"+orgName+"' and enablestate = '2' and dr = 0";
		return  (String) iuap.executeQuery(sql.toString(), new ColumnProcessor());
	}
}
