package nc.pub.filesystem.newui;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import javax.swing.AbstractAction;
import javax.swing.Action;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import nc.itf.uap.IVOPersistence;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.funcnode.ui.action.AbstractNCAction;
import nc.itf.bd.defdoc.IDefdocService;
import nc.itf.th.IThOcrService;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.pub.SqlBuilder;

/**
 * ȡƱƷƱ
 * @author y1456
 * 
 */
public class ThSelectAction extends AbstractNCAction{
	
	private IVOPersistence IVOPersistence = (IVOPersistence) NCLocator.getInstance().lookup(IVOPersistence.class);
	private ThFileContentPanel parentpanel;
	private IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	
	public ThSelectAction(ThFileContentPanel para){
		parentpanel = para;
		this.putValue(AbstractAction.NAME,"Ʊȡ");
		this.putValue(Action.SHORT_DESCRIPTION, "Ʊȡ");
	}

	@Override
	public void actionPerformed(ActionEvent actionevent) {
		MessageDialog.showHintDlg(parentpanel, "ʾ","ʼƱȡ");
		String vdef17 =(String) parentpanel.editor_.getBillCardPanel().getHeadItem("vdef17").getValueObject();//id
		String pk_group = (String) parentpanel.editor_.getBillCardPanel().getHeadItem("pk_group").getValueObject();
		String billmaker = InvocationInfoProxy.getInstance().getUserId();
		IThOcrService  ocrservice=(IThOcrService) NCLocator.getInstance().lookup(IThOcrService.class.getName());
		
		//ȡtoken
		String token="";
		JSONObject json = null;
		try {
			 token=ocrservice.getToken(billmaker);
		} catch (Exception e) {
			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,"ȡtoken:\n"+e.getMessage());
			return;
		}
		
		try {
			json = ocrservice.SelectORCInvoice(token);
		} catch (Exception e) {
			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,"ȡƱƷƱ:\n"+e.getMessage());
		}
		try {
			//õݶӦɾֵ
			DeleteDOC(vdef17);
			JSONObject data = json.getJSONObject("data");
			JSONArray infos = data.getJSONArray("infos");
			//ƱвڷƱ
			if(infos != null) {
				for(int j = 0;j < infos.size();j++){
					JSONObject info = infos.getJSONObject(j);
					String memo = info.getString("number");//Ʊ
					String code = info.getString("number");//Ʊ
					String fid = info.getString("fid");
					
					//ԶѴڸ÷Ʊ
					if(QryOCRNumber(vdef17, code) != null) {
						continue;
					}
					//ⷢƱƱźͷƱ벻
					if(code == null || "".equals(code)) {
						memo = "ⷢƱ"+fid;
						code = fid;
					}
					String ext = info.getString("ext");
					JSONObject extobj = JSONObject.parseObject(ext);
					String trate = extobj.getString("trate");//˰
					
					JSONObject modify_info = info.getJSONObject("modify_info");
					String name = modify_info.getString("fname");
					JSONObject comm_info = info.getJSONObject("comm_info");
					JSONObject pro = comm_info.getJSONObject("pro");
					String date = pro.getString("date");//Ʊ
					String type = pro.getString("type");//Ʊ
					String cname = pro.getString("cname");//Ʊ
					String kind = pro.getString("kind");//Ʊ
					JSONObject price = comm_info.getJSONObject("price");
					String amount = "";
					String total = "";
					String dtax = "";
					//רƱ˰רƱ˰=˰ϼ
					if(type.equals("1")||type.equals("28")||type.equals("32")){
						amount = price.getString("amount");//˰
						total = price.getString("total");//˰ϼ
						dtax = price.getString("dtax");//ɵֿ˰
					}
					else{
						amount = price.getString("total");//˰
						total = amount;//˰ϼ
						dtax = "0";//ɵֿ˰
						trate = "0";//רƱ˰ҲΪ0
					}
					JSONObject buyer = comm_info.getJSONObject("buyer");
					String mnecode = buyer.getString("tcode");//˰ʶ
					String name2 = buyer.getString("company");//򷽹˾
					JSONObject payer = comm_info.getJSONObject("payer");
					String name3 = payer.getString("tcode");//۷˰ʶ
					String name4 = payer.getString("company");//򷽹˾
					
					IDefdocService idefservice = NCLocator.getInstance().lookup(IDefdocService.class);
					DefdocVO[] vos = new DefdocVO[1];
					DefdocVO defvo = new DefdocVO();
					//ֵ
					//ΪԶ嵵code,nameظϺ׺Ϊ,޷ƱƻȡƱʹ
					defvo.setAttributeValue("code", code+"-"+System.currentTimeMillis());
					defvo.setAttributeValue("name", memo+"-"+System.currentTimeMillis());
					defvo.setAttributeValue("memo", name );
					defvo.setAttributeValue("mnecode", mnecode);
					defvo.setAttributeValue("name2", name2);
					defvo.setAttributeValue("name3", name3);
					defvo.setAttributeValue("name4", name4);
					defvo.setAttributeValue("name5", fid);
					defvo.setAttributeValue("name6", vdef17);
					defvo.setAttributeValue("pk_defdoclist", QryOCRPk());
					defvo.setAttributeValue("pk_group", pk_group);
					defvo.setAttributeValue("pk_org", pk_group);
					defvo.setAttributeValue("datatype", 1);
					defvo.setAttributeValue("enablestate", 2);
					defvo.setAttributeValue("shortname", amount);
					defvo.setAttributeValue("shortname2", total);
					defvo.setAttributeValue("shortname3", dtax);
					defvo.setAttributeValue("pid", date);
					defvo.setAttributeValue("shortname5", cname);
					defvo.setAttributeValue("shortname6", trate);
					defvo.setAttributeValue("enablestate", 2);
					defvo.setAttributeValue("innercode", "1");
					defvo.setAttributeValue("shortname4", kind);
					vos[0] = defvo;
					idefservice.insertDefdocs(pk_group, vos);
					}
				}
			} catch (Exception e) {
				// TODO Զɵ catch 
				MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
						,"Զ嵵:\n"+e.getMessage());
				return;
			}
		MessageDialog.showHintDlg(parentpanel, "ʾ","ȡɹ");
	}
	
    @SuppressWarnings("unchecked")
	private DefdocVO[]  QryDefdocvoInfo(String code) throws Exception{
        String sql = "select * from  bd_defdoc where  nvl(dr, 0) = 0 and pk_defdoclist="
        		+ "(select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0) and code='" + code + "' ";
        ArrayList<Object> arrayvos=null;
			arrayvos=(ArrayList<Object>) iuap.executeQuery(sql, new BeanListProcessor(DefdocVO.class));
        	
        if (arrayvos==null||arrayvos.size()==0) {
      		return new DefdocVO[0];
      	}else {
      		return arrayvos.toArray(new DefdocVO[0]);
      	}
    } 
    
    //ѯԶ嵵pk
    private String QryOCRPk() throws Exception{
    	String sql = "select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0";
    	Object object = null;
			object = iuap.executeQuery(sql, new ColumnProcessor());
		if (object==null) {
			return null;
		}else {
			return object.toString();
		}
    }
    //ѯƱǷԶѴ
    private String QryOCRNumber(String vdef17,String number) throws Exception{
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT");
    	sql.append(" pk_defdoc ");
    	sql.append(" FROM");
    	sql.append(" bd_defdoc");
    	sql.append(" WHERE");
    	sql.append(" name6 = '"+vdef17+"'");
    	sql.append(" AND code = '"+number+"'");
    	sql.append(" AND nvl( dr, 0 ) = 0");
		String pk_defdoc = (String) iuap.executeQuery(sql.toString(), new ColumnProcessor());
		return pk_defdoc;
    }
    
    
    //ɾ
    private void DeleteDOC(String vdef17) throws Exception {
    	SqlBuilder sql = new  SqlBuilder();
    	sql.append(" name6 = '"+vdef17+"'");
    	sql.append(" AND innercode = '1'");
    	sql.append(" AND pk_defdoclist = ( SELECT pk_defdoclist FROM bd_defdoclist WHERE code = 'OCRTHNC' AND nvl( dr, 0 ) = 0 )");
    	IVOPersistence.deleteByClause(DefdocVO.class, sql.toString());
    }

}
