package nc.ui.hr.baod_orders.ace.handler;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.SpecialDataUtil;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.ui.hr.baod_orders.view.ShowMoneyDialog;
import nc.ui.pubapp.uif2app.event.IAppEventHandler;
import nc.ui.pubapp.uif2app.event.card.CardHeadTailAfterEditEvent;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

/**
 * ݱͷβֶα༭¼
 * 
 * @since 6.0
 * @version 2011-7-7 02:52:22
 * @author duy
 */
public class AceHeadTailAfterEditHandler implements IAppEventHandler<CardHeadTailAfterEditEvent> {

	private IUAPQueryBS bs = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	private SimpleDateFormat sdf = new  SimpleDateFormat("yyyy-MM-dd");
    @Override
    public void handleAppEvent(CardHeadTailAfterEditEvent e) {
    	try {
    		String key = e.getKey();
    		if ("clerkcode".equals(key)) {
    			emptyData(e);	
    			// ȡǰԱ
    			String pk_id =  (String) e.getBillCardPanel().getHeadItem("clerkcode").getValueObject();
    	 		if(pk_id != null) {
	       	 		Map<String,String> psnjobmap = getPsnjobByID(pk_id);
	       	 		//
	       	 		e.getBillCardPanel().setHeadItem("clerkname", getPsnName(pk_id));
	       	 		//ڹ˾
	    	    	e.getBillCardPanel().setHeadItem("def1", psnjobmap.get("hrorgname"));
	   	    	 	//ڲ
	   	    	 	e.getBillCardPanel().setHeadItem("deptname", psnjobmap.get("deptname"));
	   	    	 	//ְλ
	   	    	 	e.getBillCardPanel().setHeadItem("postname", psnjobmap.get("postname"));
	   	    	 	//
	   	    	 	//e.getBillCardPanel().setHeadItem("bdtype", psnjobmap.get("bdtype"));
    	 		}
    		}
    		//׿ʼ
    		if("start_cycle".equals(key)) {
		    	specialData(e,"start_cycle");   	 		
		   	 }
    		//׽ֹ
		    if("finish_cycle".equals(key)) {
		    	specialData(e,"finish_cycle");	
		   	 }  
    	} catch (Exception e2) {
    		ExceptionUtils.wrappBusinessException(""+e2.getMessage());
    	}	
   }
    
   //α٣ɹֵ
    public void specialData(CardHeadTailAfterEditEvent e,String str) throws Exception {
    	//ȡǰԱ
    	String clerkcode =  (String) e.getBillCardPanel().getHeadItem("clerkcode").getValueObject(); 	
    	//α׿ʼ
    	UFDate start_cycle = (UFDate) e.getBillCardPanel().getHeadItem("start_cycle").getValueObject();  	
    	//α׽ֹ
    	UFDate finish_cycle = (UFDate) e.getBillCardPanel().getHeadItem("finish_cycle").getValueObject();  
    	//Աšα׿ʼڡα׽ֹڶд
    	if(clerkcode != null   && start_cycle != null && finish_cycle != null) {
    		//ȥʱںȽ
    		String start_cycles = start_cycle.toString().substring(0, 10);
    		String finish_cycles = finish_cycle.toString().substring(0, 10);
    		UFDate bdaccepted_period = null;
    		UFDate def2 = null;
	    	UFDate def3 = null;
	    	int def4 = 0;
	    	UFDouble bdaccepted_mount = new UFDouble(UFDouble.ZERO_DBL);
	   	 	List<Map<String,String>> bdmap = getbdData(clerkcode);
	   	 	//ʱƥı
	   	 	List<Map<String,String>> listmap =  new ArrayList<Map<String,String>>();
	   	 	//α׽
	   	 	UFDouble bdamount = new UFDouble(UFDouble.ZERO_DBL);
	   	 	UFDate bdcontract_period =  null; 
	   	 	String bdtype = "˾߳ŵ";
	   	 	//ѭϢ
	   	 	for (int i = 0; i < bdmap.size(); i++) {
	   	 		Map<String,String> map = bdmap.get(i);
	   	 		//ʼ
	   	 		UFDate begindate = new UFDate(map.get("begindate"));
	   	 		//
	   	 		UFDate glbdef7 = new UFDate(map.get("glbdef7"));
	   	 		//α׿ʼʱСڵڽʱ䣬α׽ֹʱڵڿʼʱ
	   	 		if(start_cycle.compareTo(glbdef7) <= 0 && finish_cycle.compareTo(begindate) >= 0) {
	   	 			bdtype = "ǩԼ׺ͬ";
	   	 			listmap.add(map);
	   	 			bdamount = new UFDouble(String.valueOf(map.get("glbdef2")));
	   	 			//ʼ
	   	 			if(bdcontract_period == null) {
	   	 				bdcontract_period = begindate;
	   	 				def2 = glbdef7;
	   	 			}
	   	 			// 鿪ʼǷСڵǰѭʼڣǣ򽫿ʼڸΪǰѭʼ
	   	 			if(bdcontract_period.compareTo(begindate) == 1) {
	   	 				bdcontract_period = begindate;
	   	 			}
	   	 			
	   	 			// Ƿڵǰѭڣǣ򽫽ڸΪǰʼ
	   	 			if(def2.compareTo(glbdef7) == -1) {
	   	 				def2 = glbdef7;
	   	 			}
	   	 		}
			}
	   	 	//
	    	e.getBillCardPanel().setHeadItem("bdtype", bdtype);
	   	 
	   	 	//ݴ1׽Ƶֹд,ߵ0ʾܾͷŵףƵֹд
	   	 	if(listmap.size() == 0 ||listmap.size() >= 2) {
	   	 		new ShowMoneyDialog(e,listmap).showModal();
	   	 	}else {
	   	 		//׺ͬʼ
		   	 	e.getBillCardPanel().setHeadItem("bdcontract_period", bdcontract_period);
		   	 	//׺ֹͬ
		   	 	e.getBillCardPanel().setHeadItem("def2", def2);
	   	 		//׽
		   	 	e.getBillCardPanel().setHeadItem("bdamount", bdamount.multiply(10000));
		   	 	//׽޸ģں׽ж
		   	 	e.getBillCardPanel().setHeadItem("def11", bdamount.multiply(10000));
	   	 	}
	   	 	//ѷʼ
	   	 	UFDate def7 = (UFDate) e.getBillCardPanel().getHeadItem("def7").getValueObject();
	   	 	//ѷʼڵڿղظѯͽѷʼֵָ
	   	 	if(def7 == null) {
	   	 		e.getBillCardPanel().setHeadItem("def7", getDate(clerkcode));
	   	 	}
	    	//׺ͬѱ
	    	List<Map<String,String>> listMap = GetbdDateOrMoney(clerkcode,start_cycles,finish_cycles);
	    	//׺ͬѱݵڿգ׺ͬѱΪգΪ0
	    	for (int i = 0; i < listMap.size(); i++) {
	    		Map<String,String> map = listMap.get(i);
	    		//ʼ
	    		UFDate begindate = new UFDate(map.get("begindate"));
    	 		//
    	 		UFDate enddate = new UFDate(map.get("enddate"));
    	 		//ӱɴ
	 			def4 ++;
	 			///ʼ
	 			if(bdaccepted_period == null) {
	 				bdaccepted_period = begindate;
	 				def3 = enddate;
	 			}
	 			// 鿪ʼǷСڵǰѭʼڣǣ򽫿ʼڸΪǰѭʼ
	 			if(bdaccepted_period.compareTo(begindate) == 1) {
	 				bdaccepted_period = begindate;
	 			}
	 			// Ƿڵǰѭڣǣ򽫽ڸΪǰʼ
	 			if(def3.compareTo(enddate) == -1) {
	 				def3 = enddate;
	 			}
    	 		//ϼƱ׺ͬѱ׽
    	 		bdaccepted_mount = bdaccepted_mount.add(new UFDouble(String.valueOf(map.get("money"))));
			}
   	    	//׺ͬѱ׿ʼ
   	    	e.getBillCardPanel().setHeadItem("bdaccepted_period", bdaccepted_period);
   	    	//׺ͬѱ׽
   	    	e.getBillCardPanel().setHeadItem("def3", def3);
   	    	//׺ͬѱ׽
   	    	e.getBillCardPanel().setHeadItem("bdaccepted_mount", bdaccepted_mount);
   	    	//ɴ
   	    	e.getBillCardPanel().setHeadItem("def4", def4);
   	    	//ʱʱȥںȽ
   	    	if(bdcontract_period != null && def2!= null && finish_cycles!= null) {
	   	    	UFDate bdcontract_periodDate = new UFDate(bdcontract_period.toString().substring(0, 10));
	   	    	UFDate def2Date = new UFDate(def2.toString().substring(0, 10));
	   	    	UFDate finish_cycleDate = new UFDate(finish_cycles);
	    		if(finish_cycleDate.compareTo(bdcontract_periodDate) == -1) {
	    			e.getBillCardPanel().setHeadItem(str, null);
	        		ExceptionUtils.wrappBusinessException("α׽ֹʱڵڱ׺ͬʼʱ䣡");
	        	}
	        	if(finish_cycleDate.compareTo(def2Date) == 1) {
	        		e.getBillCardPanel().setHeadItem(str, null);
	        		ExceptionUtils.wrappBusinessException("α׽ֹʱСڵڱ׺ֹͬʱ!");
	        	}
   	    	}
    		JSONObject jsonObject = SpecialDataUtil.getWorkDays(start_cycles, finish_cycles, clerkcode);
    		//αٹ
    		UFDouble leave_days = new UFDouble(UFDouble.ZERO_DBL);
    		//αʵɹ
    		UFDouble work_days = new UFDouble(UFDouble.ZERO_DBL);
    		if("1".equals(jsonObject.getString("code"))) {
    			JSONObject data = jsonObject.getJSONObject("data");
    			leave_days = new UFDouble(data.getString("leaveday"));
    			work_days = new UFDouble(data.getString("workday"));
    			e.getBillCardPanel().setHeadItem("leave_days", leave_days);
    			e.getBillCardPanel().setHeadItem("work_days", work_days);
    		}else {
    			e.getBillCardPanel().setHeadItem(str, null);
    			ExceptionUtils.wrappBusinessException("ȡʧ:"+jsonObject.get("msg"));
    		}
    		Object startDate = e.getBillCardPanel().getHeadItem("bdcontract_period").getValueObject();
    		Object endDate = e.getBillCardPanel().getHeadItem("def2").getValueObject();
    	   	if(startDate != null && endDate!= null) {
    	   		//ȡ׺ͬڼн
    	   		JSONObject jsonData = SpecialDataUtil.getWorkDays(startDate.toString().substring(0, 10), endDate.toString().substring(0, 10), clerkcode);
    	   		if("1".equals(jsonData.getString("code"))) {
	    	   		JSONObject data = jsonData.getJSONObject("data");
	    	   		UFDouble leaveday = new UFDouble(data.getString("leaveday"));
	    	   		UFDouble workday = new UFDouble(data.getString("workday"));
	    	   		//н = +
	    	   		e.getBillCardPanel().setHeadItem("def9", leaveday.add(workday));
	    	   	}else {
	    	   		ExceptionUtils.wrappBusinessException("ȡ׺ͬڼнʧ:"+jsonObject.get("msg"));
	    	   	}
    	   	}
    	}
    }
    
    //ԱIDԱ
    public String getPsnName(String pk_id) throws BusinessException {
    	String sql = "select name from bd_psndoc where pk_psndoc = '"+pk_id+"'";
		return (String) bs.executeQuery(sql, new ColumnProcessor());
    	
    }

   //ԱIDѯԱӦ֯ţλϢ
   public Map<String,String> getPsnjobByID(String pk_id) throws BusinessException{
	   StringBuffer sql = new StringBuffer();
	   sql.append("SELECT");
	   sql.append(" hi_psnjob.clerkcode as clerkcode,");
	   sql.append(" bd_psndoc.name as name,");
	   sql.append(" org_hrorg.name AS hrorgname,");
	   sql.append(" org_dept.name AS deptname,");
	   sql.append(" om_post.postname AS postname");
	   sql.append(" FROM");
	   sql.append(" hi_psnjob hi_psnjob");
	   sql.append(" LEFT JOIN bd_psndoc bd_psndoc ON hi_psnjob.pk_psndoc = bd_psndoc.pk_psndoc");
	   sql.append(" LEFT JOIN org_hrorg org_hrorg ON hi_psnjob.pk_hrorg = org_hrorg.pk_hrorg");
	   sql.append(" LEFT JOIN org_dept org_dept ON hi_psnjob.pk_dept = org_dept.pk_dept");
	   sql.append(" LEFT JOIN om_post om_post ON hi_psnjob.pk_post = om_post.pk_post");
	   sql.append(" WHERE");
	   sql.append(" hi_psnjob.lastflag = 'Y' ");
	   sql.append(" AND hi_psnjob.endflag = 'N' ");
	   sql.append(" AND hi_psnjob.ismainjob = 'Y' ");
	   sql.append(" AND hi_psnjob.pk_psndoc = '"+pk_id+"'");
	   Map<String, String> psnjobmap = (Map<String, String>) bs.executeQuery(sql.toString(), new MapProcessor());
	   //ΪĬֵ
	   if(psnjobmap == null) {
		   Map<String, String> map = new HashMap<String, String>(); 
		   map.put("hrorgname", null);
		   map.put("deptname", null);
		   map.put("deptname", null);
		   map.put("bdtype", "˾߳ŵ");
		   psnjobmap = map;	
	   }else {
   			psnjobmap.put("bdtype", "ǩԼ׺ͬ");
	   }
		return psnjobmap;
   }
   
   //ԱŲѯԱӦ֯ţλϢ
   public Map<String,String> getPsnjobByCode(String code) throws BusinessException{
	   StringBuffer sql = new StringBuffer();
	   sql.append("SELECT");
	   sql.append(" hi_psnjob.pk_psndoc AS pk_psndoc,");
	   sql.append(" org_hrorg.name AS hrorgname,");
	   sql.append(" org_dept.name AS deptname,");
	   sql.append(" om_post.postname AS postname");
	   sql.append(" FROM");
	   sql.append(" hi_psnjob hi_psnjob");
	   sql.append(" LEFT JOIN org_hrorg org_hrorg ON hi_psnjob.pk_hrorg = org_hrorg.pk_hrorg");
	   sql.append(" LEFT JOIN org_dept org_dept ON hi_psnjob.pk_dept = org_dept.pk_dept");
	   sql.append(" LEFT JOIN om_post om_post ON hi_psnjob.pk_post = om_post.pk_post");
	   sql.append(" WHERE");
	   sql.append(" hi_psnjob.lastflag = 'Y' ");
	   sql.append(" AND hi_psnjob.endflag = 'N' ");
	   sql.append(" AND hi_psnjob.ismainjob = 'Y' ");
	   sql.append(" AND hi_psnjob.clerkcode = '"+code+"'");
	   Map<String, String> psnjobmap = (Map<String, String>) bs.executeQuery(sql.toString(), new MapProcessor());
	   //ΪĬֵ
	   if(psnjobmap == null) {
		   Map<String, String> map = new HashMap<String, String>(); 
		   map.put("hrorgname", null);
		   map.put("deptname", null);
		   map.put("deptname", null);
		   map.put("bdtype", "˾߳ŵ");
		   psnjobmap = map;	
	   }else {
		   psnjobmap.put("bdtype", "ǩԼ׺ͬ");
	   }
		return psnjobmap;
   }
   
   //ѯԱӦıϢ
   public List<Map<String, String>> getbdData(String clerkcode)throws BusinessException{
	   String sql ="SELECT BEGINDATE,ENDDATE,GLBDEF2,GLBDEF7 FROM hi_psndoc_glbdef15 WHERE  pk_psndoc = '"+clerkcode+"' AND GLBDEF6 = 'Y' ";
	   List<Map<String, String>> bdmap = (List<Map<String, String>>) bs.executeQuery(sql.toString(), new MapListProcessor());
	   return bdmap;   
   }
   
   //Աձ
   public void emptyData(CardHeadTailAfterEditEvent e)throws BusinessException{
	   e.getBillCardPanel().setHeadItem("attrname", null);
	   e.getBillCardPanel().setHeadItem("bdaccepted_mount", null);
	   e.getBillCardPanel().setHeadItem("bdaccepted_period", null);
	   e.getBillCardPanel().setHeadItem("bdamount", null);
	   e.getBillCardPanel().setHeadItem("bdcontract_period", null);
	   e.getBillCardPanel().setHeadItem("bdtype", null);
	   e.getBillCardPanel().setHeadItem("clerkname", null);
	   e.getBillCardPanel().setHeadItem("days_ratio", null);
	   e.getBillCardPanel().setHeadItem("def1", null);
	   e.getBillCardPanel().setHeadItem("def2", null);
	   e.getBillCardPanel().setHeadItem("def3", null);
	   e.getBillCardPanel().setHeadItem("def4", null);
	   e.getBillCardPanel().setHeadItem("def5", null);
	   e.getBillCardPanel().setHeadItem("def6", null);
	   e.getBillCardPanel().setHeadItem("def7", null);
	   e.getBillCardPanel().setHeadItem("def8", null);
	   e.getBillCardPanel().setHeadItem("def9", null);
	   e.getBillCardPanel().setHeadItem("def11", null);
	   e.getBillCardPanel().setHeadItem("deptname", null);
	   e.getBillCardPanel().setHeadItem("dfbonus_total", null);
	   e.getBillCardPanel().setHeadItem("dfdesign_bonus", null);
	   e.getBillCardPanel().setHeadItem("dfmanage_bonus", 0.00);
	   e.getBillCardPanel().setHeadItem("dfmarket_bonus", null);
	   e.getBillCardPanel().setHeadItem("dfservice_charge", null);
	   e.getBillCardPanel().setHeadItem("dfteam_bonus", null);
	   e.getBillCardPanel().setHeadItem("finish_cycle", null);
	   e.getBillCardPanel().setHeadItem("income_total", null);
	   e.getBillCardPanel().setHeadItem("leave_days", null);
	   e.getBillCardPanel().setHeadItem("mount_total", null);
	   e.getBillCardPanel().setHeadItem("postname", null);
	   e.getBillCardPanel().setHeadItem("remark", null);
	   e.getBillCardPanel().setHeadItem("scheme", null);
	   e.getBillCardPanel().setHeadItem("baod_type", null);
	   e.getBillCardPanel().setHeadItem("start_cycle", null);
	   e.getBillCardPanel().setHeadItem("subsidy_mount", null);
	   e.getBillCardPanel().setHeadItem("this_amount", null);
	   e.getBillCardPanel().setHeadItem("work_days", null);
	   e.getBillCardPanel().setHeadItem("yfbonus_total", null);
	   e.getBillCardPanel().setHeadItem("yfdesign_bonus", null);
	   e.getBillCardPanel().setHeadItem("yfmanage_bonus", null);
	   e.getBillCardPanel().setHeadItem("yfmarket_bonus", null);
	   e.getBillCardPanel().setHeadItem("yfmonthly_pay", null);
	   e.getBillCardPanel().setHeadItem("yfpredict_bonus", null);
	   e.getBillCardPanel().setHeadItem("yfservice_charge", null);
	   e.getBillCardPanel().setHeadItem("yfteam_bonus", null);  
   }
   
   public String getDate(String clerkcode) throws Exception {
	   String sql = "select MAX(def8) as def8 from baod_order where clerkcode = '"+clerkcode+"' and dr = 0 and approvestatus = '1' order by def8 desc";
	   String def8 = (String) bs.executeQuery(sql, new ColumnProcessor());
	   if(def8 != null) {
		   Calendar calendar = Calendar.getInstance(); 
		   calendar.setTime(sdf.parse(def8)); 
		   calendar.add(Calendar.DAY_OF_MONTH, 1); //  1  
		   return sdf.format(calendar.getTime());  
	   }
	   return null;
   }
   
   //ѯ׺ͬѱ׽ֹڴڱ׺ֹͬ
   public List<Map<String, String>> GetbdDateOrMoney(String clerkcode, String startdate, String enddate) throws Exception{
	   //ѯԱײ
	   String sql = "select income_total as money,start_cycle as begindate,finish_cycle as enddate from baod_order  where clerkcode ='"+clerkcode+"' "
	   		+ "and (SUBSTR(finish_cycle,1,10) >= '"+startdate+"'and SUBSTR(start_cycle,1,10) <= '"+enddate+"') and approvestatus = '1' and dr = 0";
	   List<Map<String,String>> listMap = (List<Map<String, String>>) bs.executeQuery(sql, new MapListProcessor());
	   //ԱײûвѯԱתȡڳ,жӦȡڳ
	   if(listMap.size() == 0) {
		   //ѯڳ
		    sql = "select guaranteed_start_date as begindate,guaranteed_end_date as enddate,guaranteed_amount as money "
		   		+ "from employees_guarantee_contract where pk_psndoc = '"+clerkcode+"' and (contract_start_date >='"+startdate+"' and contract_end_date <= '"+enddate+"')"; 
		    listMap = (List<Map<String, String>>) bs.executeQuery(sql, new MapListProcessor());
	   }
	   return listMap;
   }
}
