package nc.ui.hr.baod_orders.view;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Vector;

import javax.swing.JProgressBar;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.desktop.ui.WorkbenchEnvironment;
import nc.hr.utils.OutputDialogUtil;
import nc.itf.hr.SocialInsuranceAllMaintain;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.ui.pub.ButtonObject;
import nc.ui.pub.ToftPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UILabel;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.beans.UITablePane;
import nc.ui.pub.beans.ValueChangedEvent;
import nc.ui.pub.beans.ValueChangedListener;
import nc.ui.pub.link.BillLinkOneNodeCenter;
import nc.vo.fipub.exception.ExceptionHandler;
import nc.vo.fipub.freevalue.Module;
import nc.vo.gl.pubvoucher.DetailVO;
import nc.vo.gl.pubvoucher.OperationResultVO;
import nc.vo.gl.pubvoucher.VoucherVO;
import nc.vo.glcom.ass.AssVO;
import nc.vo.glcom.tools.GLPubProxy;
import nc.vo.pub.BusinessException;
import nc.vo.pub.SuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.pub.MathTool;
import nc.vo.uap.rbac.profile.FunctionPermProfileManager;

/**
 * ѷ̯
 * 
 * @author YaoYu
 * 
 */
public class ServiceChargeAllocationUI extends ToftPanel {
	private IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private ButtonObject bt_query = new ButtonObject("ѯ", "", 2, "bt_query");
	private ButtonObject bt_update = new ButtonObject("޸", "", 2, "bt_update");
	private ButtonObject bt_output = new ButtonObject("", "", 2, "bt_output");
	private ButtonObject bt_voucher = new ButtonObject("ƾ֤", "", 2, "bt_voucher");
	private ButtonObject bt_linkvouchar = new ButtonObject("ƾ֤", "", 2, "bt_linkvouchar");

	private JProgressBar pb;
	private UITablePane tablepanel = null;
	private UIPanel ivjUIPanel0 = null;
	private UIPanel ivjUIPanel2 = null;
	private UIPanel ivjUIPanel4 = null;
	private UIPanel ivjUIPanel45 = null;
	private UILabel ivjOrgLabel = null;
	private UILabel ivjperiodLabel = null;
	private UIRefPane ivjcostcpanel = null;
	private UIRefPane ivjOrgPanel = null;
	private UIRefPane ivjperiodpanel = null;
	private UITablePane ivjTablePanel = null;
	private String[] subheading = { "", "Ա", "", "ɷѻ", "˲", "˾", "ע" };
	private String[] subheadings = { "", "Ա", "", "ɷѻ", "˾", "ע" };
	private Map<String, Map<String, UFDouble>> beforePsgMoney = null; // ǰ
	private Map<String, Map<String, UFDouble>> afterPsgMoney = null; // 
	private String orgCode;// ѯ֯
	private String period;// ѯڼ
	Map<String, Map<String, String>> middleTableData = new HashMap<String, Map<String, String>>();// м
	private SocialInsuranceAllMaintain siaMaintain = NCLocator.getInstance().lookup(SocialInsuranceAllMaintain.class);

	public ServiceChargeAllocationUI() {
		initialize();
		tablepanel = getTablePanel();
	}

	@Override
	public String getTitle() {
		return "ѷ̯";
	}

	public void initialize() {
		setLayout(new BorderLayout());
		add(getUIPanel0(), BorderLayout.NORTH);
		add(getUIPanel2(), BorderLayout.CENTER);
		add(getUIPanel4(), BorderLayout.SOUTH);
		setButtons(new ButtonObject[] { this.bt_query, this.bt_update, this.bt_output, this.bt_voucher, this.bt_linkvouchar });// Ӱť
	}

	private UILabel getOrgLabel() {
		if (this.ivjOrgLabel == null) {
			this.ivjOrgLabel = new UILabel();
			this.ivjOrgLabel.setName("pkorg");
			this.ivjOrgLabel.setText("֯");
		}
		return this.ivjOrgLabel;
	}

	private UIRefPane getOrgPanel() {
		if (this.ivjOrgPanel == null) {
			// ڵ
			String nodeCode = "60H20105";
			this.ivjOrgPanel = new UIRefPane();
			this.ivjOrgPanel.setName("pkorg");
			this.ivjOrgPanel.setRefNodeName("֯");
			// Ȩ֯
			String[] pkorgs = FunctionPermProfileManager.getInstance().getProfile(WorkbenchEnvironment.getInstance().getLoginUser().getUser_code()).getFuncSubInfo(nodeCode).getFuncPermissionPkorgs();
			this.ivjOrgPanel.getRefModel().setFilterPks(pkorgs);
			this.ivjOrgPanel.setBounds(new Rectangle(100, 20));
			this.ivjOrgPanel.setPreferredSize(new Dimension(170, 20));
			// this.ivjOrgPanel.setMultiSelectedEnabled(true);
			this.ivjOrgPanel.addValueChangedListener(new ValueChangedListener() {
				public void valueChanged(ValueChangedEvent e) {
					ServiceChargeAllocationUI.this.initialize();
				}
			});
		}
		return this.ivjOrgPanel;
	}

	private UILabel getperiodclabel() {
		if (this.ivjperiodLabel == null) {
			this.ivjperiodLabel = new UILabel();
			this.ivjperiodLabel.setName("period");
			this.ivjperiodLabel.setText("");
		}
		return this.ivjperiodLabel;
	}

	private UIRefPane getperiodpanel() {
		if (this.ivjperiodpanel == null) {
			this.ivjperiodpanel = new UIRefPane();
			this.ivjperiodpanel.setName("period");
			this.ivjperiodpanel.setRefNodeName("ڼ䵵");
			this.ivjperiodpanel.setBounds(new Rectangle(100, 20));
			this.ivjperiodpanel.setPreferredSize(new Dimension(170, 20));
			this.ivjperiodpanel.addValueChangedListener(new ValueChangedListener() {
				public void valueChanged(ValueChangedEvent e) {
					ServiceChargeAllocationUI.this.initialize();
				}
			});
		}
		return this.ivjperiodpanel;
	}

	private UIPanel getUIPanel0() {
		if (this.ivjUIPanel0 == null) {
			try {
				this.ivjUIPanel0 = new UIPanel();
				this.ivjUIPanel0.setLayout(new BorderLayout());
				UIPanel sel = new UIPanel();
				sel.setLayout(new FlowLayout());
				sel.add(getOrgLabel());
				sel.add(getOrgPanel());
				sel.add(getperiodclabel());
				sel.add(getperiodpanel());
				this.ivjUIPanel0.add(sel, BorderLayout.WEST);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return this.ivjUIPanel0;
	}

	private UIPanel getUIPanel4() {
		if (this.ivjUIPanel4 == null) {
			this.ivjUIPanel4 = new UIPanel();
			this.ivjUIPanel4.setLayout(new BorderLayout());
			this.ivjUIPanel4.add(getUILabel45(), BorderLayout.CENTER);
		}
		return this.ivjUIPanel4;
	}

	private UIPanel getUILabel45() {
		if (this.ivjUIPanel45 == null) {
			try {
				this.ivjUIPanel45 = new UIPanel();
				this.ivjUIPanel45.setName("UIPanel3");
				this.ivjUIPanel45.setPreferredSize(new Dimension(0, 10));
				this.ivjUIPanel45.setLayout(new BorderLayout());
				this.ivjUIPanel45.add(getprogressbar(), BorderLayout.EAST);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return this.ivjUIPanel45;
	}

	private void handleException(Throwable e) {
		ExceptionHandler.consume(e);
	}

	private JProgressBar getprogressbar() {
		if (this.pb == null) {
			this.pb = new JProgressBar();
			this.pb.setIndeterminate(false);
		}
		return pb;
	}

	private UIPanel getUIPanel2() {
		if (this.ivjUIPanel2 == null) {
			this.ivjUIPanel2 = new UIPanel();
			this.ivjUIPanel2.setLayout(new BorderLayout());
			this.ivjUIPanel2.setPreferredSize(new Dimension(0, 500));
			this.ivjUIPanel2.add(getTablePanel(), BorderLayout.CENTER);
		}
		return this.ivjUIPanel2;
	}

	private UITablePane getTablePanel() {
		if (this.ivjTablePanel == null) {
			try {
				this.ivjTablePanel = new UITablePane();
				this.ivjTablePanel.setName("TablePanel");
				this.ivjTablePanel.setLayout(new CardLayout());
			} catch (Throwable ivjExc) {
			}
		}
		return this.ivjTablePanel;
	}

	private Vector<Object> convertovector(Object[] objArray) {
		if (objArray == null) {
			return null;
		}
		Vector<Object> v = new Vector<Object>(objArray.length);
		for (int i = 0; i < objArray.length; i++) {
			v.addElement(objArray[i]);
		}
		return v;
	}

	@Override
	public void onButtonClicked(ButtonObject bt) {
		try {
			// ֹͣ༭;
			getOrgPanel().stopEditing();
			getperiodpanel().stopEditing();
			orgCode = getOrgPanel().getRefModel().getRefCodeValue();
			Vector periodData = getperiodpanel().getRefModel().getSelectedData();
			if (periodData != null && periodData.size() > 0) {
				Vector v = (Vector) periodData.get(0);
				period = v.get(0).toString();
			}
			if (orgCode == null || period == null) {
				ExceptionUtils.wrappBusinessException("֯±ѡѡٲ");
			}
			if ("bt_query".equals(bt.getCode())) {
				// ʼ
				beforePsgMoney = new HashMap<String, Map<String, UFDouble>>();
				afterPsgMoney = new HashMap<String, Map<String, UFDouble>>();
				TableProcessing();
			} else if ("bt_update".equals(bt.getCode())) {
				update(getTablePanel());
			} else if ("bt_output".equals(bt.getCode())) {
				onoutput();
			} else if ("bt_linkvouchar".equals(bt.getCode())) {
				String pkvouchersql = "select voucher_pk from voucher_flag where tablename='ѷ̯' and orgcode='" + orgCode + "' and period='" + period + "' and nvl(dr,0)=0 ";
				Object voucher_pk = iuap.executeQuery(pkvouchersql, new ColumnProcessor());
				if (null != voucher_pk) {
					String sqlvoucher = "select num from gl_voucher where pk_voucher='" + voucher_pk + "' ";
					Object vouchernum = iuap.executeQuery(sqlvoucher, new ColumnProcessor());
					if (null != vouchernum) {
						VoucherVO[] aggvos = GLPubProxy.getRemoteVoucher().queryByPks(new String[] { voucher_pk.toString() });
						BillLinkOneNodeCenter.linkQuery_Dialog(this, "C0", new String[] { voucher_pk.toString() }, aggvos, true);
					}
				}
			} else if ("bt_voucher".equals(bt.getCode())) {
				String pkvouchersql = "select voucher_pk from voucher_flag where tablename='ѷ̯' and orgcode='" + orgCode + "' and period='" + period + "' and nvl(dr,0)=0 ";
				Object voucher_pk = iuap.executeQuery(pkvouchersql, new ColumnProcessor());
				if (null != voucher_pk) {
					String sqlvoucher = "select num from gl_voucher where pk_voucher='" + voucher_pk + "' ";
					Object vouchernum = iuap.executeQuery(sqlvoucher, new ColumnProcessor());
					if (null != vouchernum) {
						ExceptionUtils.wrappBusinessException("ƾ֤" + vouchernum + "Ѿ!ظ!");
					} else {
						// ƾ֤Ѿɾм
						StringBuilder insertSQL = new StringBuilder("update  voucher_flag set dr=1 where voucher_pk='" + voucher_pk + "' ");
						siaMaintain.executeBaseDAO(insertSQL.toString());
					}
				}
				MessageDialog.showHintDlg(this, "", "ƾ֤ʼ");
				// װƾ֤
				Map<String, UFDouble> voucheramount = getVoucherAmount(getTablePanel());
				VoucherVO voucher = getVoucherVO(voucheramount);
				for (DetailVO detail : voucher.getDetails()) {
					if (detail.getAss() != null && detail.getAss().length > 0) {
						String assIDs = GLPubProxy.getRemoteFreevaluePub().getAssID_RequiresNew(detail.getAss(), false, "", InvocationInfoProxy.getInstance().getGroupId(), Module.GL);
						detail.setAssid(assIDs);
					}
				}
				OperationResultVO[] rs = GLPubProxy.getRemoteVoucher().save((VoucherVO) voucher, new Boolean(true));
				// Ѿƾ֤ıʶpk
				String pk = rs[0].m_strPK;
				StringBuilder insertSQL = new StringBuilder("insert into voucher_flag (TABLENAME, ORGCODE, PERIOD,  VOUCHER_PK) values (");
				insertSQL.append("'").append("ѷ̯").append("',");
				insertSQL.append("'").append(orgCode).append("', ");
				insertSQL.append("'").append(period).append("', ");
				insertSQL.append("'").append(pk).append("'); ");
				siaMaintain.executeBaseDAO(insertSQL.toString());
				MessageDialog.showHintDlg(this, "ʾ", "ƾ֤");
			}
		} catch (Exception e) {
			MessageDialog.showHintDlg(this, "ʾ", e.getMessage());
		}
	}

	/**
	 * ݴȾ
	 * 
	 * @param dataList
	 * @param title
	 * @param ListMap
	 */
	private Map<String, UFDouble> addTableToList(String str, List<Object[]> dataList, String title, List<Map<String, String>> ListMap) {
		dataList.add(new Object[] { title });
		Map<String, UFDouble> sumMap = new HashMap<String, UFDouble>();
		// ϼƲ
		UFDouble SumStaff = new UFDouble(0.00, 2);
		UFDouble SumOrg = new UFDouble(0.00, 2);
		// СƲ
		UFDouble subtotalStaff = new UFDouble(0.00, 2);
		UFDouble subtotalOrg = new UFDouble(0.00, 2);
		if ("һ˳е".equals(title)) {
			dataList.add(subheading);
			for (int i = 0; i < ListMap.size(); i++) {
				Map<String, String> map = ListMap.get(i);
				Map<String, UFDouble> mapMoney = new HashMap<String, UFDouble>();
				String clerkcode = map.get("clerkcode");
				String clerkname = map.get("clerkname");
				String orgName = map.get("orgname");
				String basicssum = MathTool.nvl(ValueUtils.getUFDouble(map.get("basicssum"))).toString();
				String staffsum = MathTool.nvl(ValueUtils.getUFDouble(map.get("staffsum"))).toString();
				String orgsum = MathTool.nvl(ValueUtils.getUFDouble(map.get("orgsum"))).toString();
				String mark = map.get("mark");
				String combinedField = title + clerkcode + clerkname;
				// ȡм
				Map<String, String> middleTableMap = middleTableData.get(combinedField);
				// middleTableMapΪʹм
				if (middleTableMap != null) {
					basicssum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("basicssum"))).toString();
					staffsum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("staffsum"))).toString();
					orgsum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("orgsum"))).toString();
					mark = middleTableMap.get("mark");
				}
				UFDouble basicsMoney = nvl(basicssum, 2);
				UFDouble staffMoney = nvl(staffsum, 2);
				UFDouble orgMoney = nvl(orgsum, 2);
				int staffsumLength = staffsum.substring(staffsum.indexOf(".") + 1).length();// ˲Сλ
				int orgsumLength = orgsum.substring(orgsum.indexOf(".") + 1).length();// ˾Сλ
				// ˲ֻ߹˾Сλ2λҪн
				if (staffsumLength > 2 || orgsumLength > 2) {
					UFDouble afterPsgStaffMoney = staffMoney;
					UFDouble afterPsgOrgMoney = orgMoney;
					// ˲ֻ߹˾ִ0.0000,˲ֻ߹˾һ0Ҫн
					if (!MathTool.equals(afterPsgStaffMoney, null) || !MathTool.equals(afterPsgOrgMoney, null)) {
						// ǰԱmapݽ
						if (afterPsgMoney.get(clerkcode) != null) {
							mapMoney = afterPsgMoney.get(clerkcode);
							afterPsgStaffMoney = afterPsgStaffMoney.add(mapMoney.get("afterPsgStaffMoney"));
							afterPsgOrgMoney = afterPsgOrgMoney.add(mapMoney.get("afterPsgOrgMoney"));
						}
						// ȡǰ˲ֽ
						UFDouble beforePsgStaffMoney = beforePsgMoney.get(clerkcode).get("beforePsgStaffMoney");
						// ȡǰ˾ֽ
						UFDouble beforePsgOrgMoney = beforePsgMoney.get(clerkcode).get("beforePsgOrgMoney");
						// ˲ֽȡǰ˲ֽ˲нȥֵĲ
						if (MathTool.greaterThan(afterPsgStaffMoney, beforePsgStaffMoney)) {
							staffMoney = staffMoney.sub(afterPsgStaffMoney.sub(beforePsgStaffMoney).setScale(2, UFDouble.ROUND_HALF_UP));
						}
						// ˾ֽȡǰ˾ֽ˾нȥֵĲ
						if (MathTool.greaterThan(afterPsgOrgMoney, beforePsgOrgMoney)) {
							orgMoney = orgMoney.sub(afterPsgOrgMoney.sub(beforePsgOrgMoney).setScale(2, UFDouble.ROUND_HALF_UP));
						}
						mapMoney.put("afterPsgStaffMoney", afterPsgStaffMoney);
						mapMoney.put("afterPsgOrgMoney", afterPsgOrgMoney);
						afterPsgMoney.put(clerkcode, mapMoney);
					}
				}
				// ͳƺϼ
				SumStaff = SumStaff.add(staffMoney);
				SumOrg = SumOrg.add(orgMoney);
				if (orgName != null) {
					// ֯Ϊ֯СС
					if (i == 0) {
						// ֯С
						dataList.add(new Object[] { orgName });
					} else if (!orgName.equals(ListMap.get(i - 1).get("orgname"))) {
						// ǰ֯һ֯֯С
						// ֯С
						dataList.add(new Object[] { orgName });
					}
					// 
					dataList.add(new Object[] { i + 1, clerkcode, clerkname, basicsMoney, staffMoney, orgMoney, mark, str + orgName });
					// ͳС
					subtotalStaff = subtotalStaff.add(staffMoney);
					subtotalOrg = subtotalOrg.add(orgMoney);
					if (i + 1 == ListMap.size()) {
						// һкһС
						// С
						dataList.add(new Object[] { "С", null, null, null, subtotalOrg });
						subtotalStaff = new UFDouble(0.00, 2);
						subtotalOrg = new UFDouble(0.00, 2);
					} else if (!orgName.equals(ListMap.get(i + 1).get("orgname"))) {
						// ǰ֯һ֯С
						// С
						dataList.add(new Object[] { "С", null, null, null, subtotalOrg });
						subtotalStaff = new UFDouble(0.00, 2);
						subtotalOrg = new UFDouble(0.00, 2);
					}
				} else {
					// 
					dataList.add(new Object[] { i + 1, clerkcode, clerkname, basicsMoney, staffMoney, orgMoney, mark, str });
				}
			}
			// ϼ
			dataList.add(new Object[] { "ϼ", null, null, null, SumStaff, SumOrg });
		} else {
			dataList.add(subheadings);
			for (int i = 0; i < ListMap.size(); i++) {
				Map<String, String> map = ListMap.get(i);
				Map<String, UFDouble> mapMoney = new HashMap<String, UFDouble>();
				String clerkcode = map.get("clerkcode");
				String clerkname = map.get("clerkname");
				String orgName = map.get("orgname");
				String basicssum = MathTool.nvl(ValueUtils.getUFDouble(map.get("basicssum"))).toString();
				String staffsum = MathTool.nvl(ValueUtils.getUFDouble(map.get("staffsum"))).toString();
				String orgsum = MathTool.nvl(ValueUtils.getUFDouble(map.get("orgsum"))).toString();
				String mark = map.get("mark");
				String combinedField = null;
				if (null == orgName) {
					combinedField = title + clerkcode + clerkname;
				} else {
					combinedField = title + orgName + clerkcode + clerkname;
				}
				// ȡм
				Map<String, String> middleTableMap = middleTableData.get(combinedField);
				// middleTableMapΪʹм
				if (middleTableMap != null) {
					basicssum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("basicssum"))).toString();
					staffsum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("staffsum"))).toString();
					orgsum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("orgsum"))).toString();
					mark = middleTableMap.get("mark");
				}
				UFDouble basicsMoney = nvl(basicssum, 2);
				UFDouble staffMoney = nvl(staffsum, 2);
				UFDouble orgMoney = nvl(orgsum, 2);
				int staffsumLength = staffsum.substring(staffsum.indexOf(".") + 1).length();// ˲Сλ
				int orgsumLength = orgsum.substring(orgsum.indexOf(".") + 1).length();// ˾Сλ
				// ˲ֻ߹˾Сλ2λҪн
				if (staffsumLength > 2 || orgsumLength > 2) {
					UFDouble afterPsgStaffMoney = staffMoney;
					UFDouble afterPsgOrgMoney = orgMoney;
					// ˲ֻ߹˾ִ0.0000,˲ֻ߹˾һ0Ҫн
					if (!MathTool.equals(afterPsgStaffMoney, null) || !MathTool.equals(afterPsgOrgMoney, null)) {
						// ǰԱmapݽ
						if (afterPsgMoney.get(clerkcode) != null) {
							mapMoney = afterPsgMoney.get(clerkcode);
							afterPsgStaffMoney = afterPsgStaffMoney.add(mapMoney.get("afterPsgStaffMoney"));
							afterPsgOrgMoney = afterPsgOrgMoney.add(mapMoney.get("afterPsgOrgMoney"));
						}
						// ȡǰ˲ֽ
						UFDouble beforePsgStaffMoney = beforePsgMoney.get(clerkcode).get("beforePsgStaffMoney");
						// ȡǰ˾ֽ
						UFDouble beforePsgOrgMoney = beforePsgMoney.get(clerkcode).get("beforePsgOrgMoney");
						// ˲ֽȡǰ˲ֽ˲нȥֵĲ
						if (MathTool.greaterThan(afterPsgStaffMoney, beforePsgStaffMoney)) {
							staffMoney = staffMoney.sub(afterPsgStaffMoney.sub(beforePsgStaffMoney).setScale(2, UFDouble.ROUND_HALF_UP));
						}
						// ˾ֽȡǰ˾ֽ˾нȥֵĲ
						if (MathTool.greaterThan(afterPsgOrgMoney, beforePsgOrgMoney)) {
							orgMoney = orgMoney.sub(afterPsgOrgMoney.sub(beforePsgOrgMoney).setScale(2, UFDouble.ROUND_HALF_UP));
						}
						mapMoney.put("afterPsgStaffMoney", afterPsgStaffMoney);
						mapMoney.put("afterPsgOrgMoney", afterPsgOrgMoney);
						afterPsgMoney.put(clerkcode, mapMoney);
					}
				}
				// ͳƺϼ
				SumOrg = SumOrg.add(orgMoney);
				if (orgName != null) {
					// ֯Ϊ֯СС
					if (i == 0) {
						// ֯С
						dataList.add(new Object[] { orgName });
					} else if (!orgName.equals(ListMap.get(i - 1).get("orgname"))) {
						// ǰ֯һ֯֯С
						// ֯С
						dataList.add(new Object[] { orgName });
					}
					// 
					dataList.add(new Object[] { i + 1, clerkcode, clerkname, null, orgMoney, mark, null, str + orgName });
					// ͳС
					subtotalOrg = subtotalOrg.add(orgMoney);
					if (i + 1 == ListMap.size()) {
						// һкһС
						// С
						dataList.add(new Object[] { "С", null, null, null, subtotalOrg });
						subtotalStaff = new UFDouble(0.00, 2);
						subtotalOrg = new UFDouble(0.00, 2);
					} else if (!orgName.equals(ListMap.get(i + 1).get("orgname"))) {
						// ǰ֯һ֯С
						// С
						dataList.add(new Object[] { "С", null, null, null, subtotalOrg });
						subtotalStaff = new UFDouble(0.00, 2);
						subtotalOrg = new UFDouble(0.00, 2);
					}
				} else {
					// 
					dataList.add(new Object[] { i + 1, clerkcode, clerkname, basicsMoney, orgMoney, mark, null, str });
				}
			}
			// ϼ
			dataList.add(new Object[] { "ϼ", null, null, null, SumOrg });
		}
		sumMap.put("staff", SumStaff);
		sumMap.put("org", SumOrg);
		return sumMap;
	}

	/**
	 * Ⱦ
	 * 
	 * @param orgCode
	 * @param period
	 * @throws Exception
	 */
	private void TableProcessing() throws Exception {
		// ʼ
		beforePsgMoney = new HashMap<String, Map<String, UFDouble>>();
		afterPsgMoney = new HashMap<String, Map<String, UFDouble>>();
		middleTableData = new HashMap<String, Map<String, String>>();
		queryMiddleTable();
		String[] m_sTitle = { null, null, null, null, null, null, null, null, null };
		List<Object[]> dataList = new ArrayList<Object[]>();
		for (int i = 0; i < 6; i++) {
			Object[] row = new Object[0];
			dataList.add(row);
		}
		Map<String, Map<String, UFDouble>> tableMap = new HashMap<String, Map<String, UFDouble>>();
		List<Map<String, String>> tableOne = queryTableOne(orgCode, period);
		moneyDispose("һ˳е", tableOne);
		List<Map<String, String>> tableTwo = queryTableTwo(orgCode, period);
		moneyDispose("ⲿ˾е", tableTwo);
		List<Map<String, String>> tableThree = queryTableThree(orgCode, period);
		moneyDispose("ɲųеȫ˾е", tableThree);
		List<Map<String, String>> tableFour = queryTableFour(orgCode, period);
		moneyDispose("ģɹ˾е", tableFour);
		tableMap.put("tableOne", addTableToList("1-", dataList, "һ˳е", tableOne));
		tableMap.put("tableTwo", addTableToList("2-", dataList, "ⲿ˾е", tableTwo));
		tableMap.put("tableThree", addTableToList("3-", dataList, "ɲųеȫ˾е", tableThree));
		tableMap.put("tableFour", addTableToList("4-", dataList, "ģɹ˾е", tableFour));
		UFDouble tableOneStaff = tableMap.get("tableOne").get("staff");// ˳е˲
		UFDouble tableOneOrg = tableMap.get("tableOne").get("org");// ˳е˾
		UFDouble tableTwoStaff = tableMap.get("tableTwo").get("staff");// ⲿ˾е˲
		UFDouble tableTwoOrg = tableMap.get("tableTwo").get("org");// ⲿ˾е˾
		UFDouble tableThreeStaff = tableMap.get("tableThree").get("staff");// ųе
		UFDouble tableThreeOrg = tableMap.get("tableThree").get("org");// ųе
		UFDouble tableFourStaff = tableMap.get("tableFour").get("staff");// ˾е˲
		UFDouble tableFourOrg = tableMap.get("tableFour").get("org");// ˾е˾
		Map<String, String> TableTenMap = queryTableTen(orgCode, period);
		// UFDouble TableTenStaff = nvl(TableTenMap.get("so_staff_sum"), 2);//ʵʽ
		// UFDouble TableTenOrg = nvl(TableTenMap.get("so_org_sum"), 2);//˾ʵʽ
		// 籣˵ʵʽ = ʵʽ+˾ʵʽ
		// UFDouble actualSum = TableTenStaff.add(TableTenOrg);
		UFDouble actualSum = nvl(TableTenMap.get("agency_money"), 2);
		// ѷ̯ = ˳еˡ˾+ⲿ˾еˡ˾+ųеˡ˾+˾еˡ˾
		UFDouble sbgjjfillSum = tableOneStaff.add(tableOneOrg).add(tableTwoStaff).add(tableTwoOrg).add(tableThreeStaff).add(tableThreeOrg).add(tableFourStaff).add(tableFourOrg);
		// = SIBCO˵֧-ѷ̯
		UFDouble difference = actualSum.sub(sbgjjfillSum);
		dataList.set(0, new Object[] { "Ϣ" });
		dataList.set(1, new Object[] { "SIBCO˵֧", actualSum, "ѷ̯", sbgjjfillSum, "", difference });
		dataList.set(2, new Object[] { "˳е", "˾", tableOneOrg, "ⲿ˾е", "˾", tableTwoOrg, "ųе", "˾", tableThreeOrg });
		dataList.set(3, new Object[] { "˳е", "˲", tableOneStaff, "ⲿ˾е", "˲", null, "ųе", "˲", null });
		dataList.set(4, new Object[] { "˾е  ", "˾", tableFourOrg });
		dataList.set(5, new Object[] { "˾е  ", "˲", tableFourStaff });
		Object[][] dataArray = new Object[dataList.size()][m_sTitle.length];
		for (int i = 0; i < dataList.size(); i++) {
			Object[] rowData = dataList.get(i);
			dataArray[i] = rowData;
		}
		DefaultTableModel model = new DefaultTableModel(dataArray, m_sTitle) {
			@Override
			public boolean isCellEditable(int row, int column) {
				return false;
			}
		};
		tablepanel.getTable().setModel(model);
//		tablepanel.getTable().setSelectionMode(1); 2025-03-21
//		tablepanel.getTable().setAutoResizeMode(0);
		tablepanel.getTable().setColumnWidth(new int[] { 300, 160, 160, 160, 160, 160, 160, 160, 160 });
		TableCellRenderer renderer = new DefaultTableCellRenderer() {
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
				// øgetTableCellRendererComponent
				super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);

				// 8пʼ7ֵɰɫ
				if (row >= 8 && column == 7) {
					// ԪѡУֵͱɫͬδѡʱóɰɫ
					if (isSelected) {
						setForeground(Color.decode("#F9E2D0"));
					} else {
						setForeground(Color.white);
					}
				} else {
					setForeground(Color.BLACK);
				}
				// Ⱦ
				return this;
			}
		};
		tablepanel.getTable().getColumnModel().getColumn(7).setCellRenderer(renderer);
	}

	/**
	 * ԱͳƸˡ˾ֽ
	 * 
	 * @param ListMap
	 */
	private void moneyDispose(String title, List<Map<String, String>> ListMap) {
		for (int i = 0; i < ListMap.size(); i++) {
			Map<String, UFDouble> mapMoney = new HashMap<String, UFDouble>();
			Map<String, String> map = ListMap.get(i);
			String clerkcode = map.get("clerkcode");
			String clerkname = map.get("clerkname");
			String orgName = map.get("orgname");
			String staffMoney = null;
			String orgMoney = null;
			// orgNameܴΪյ,ƴӵʱnullƴӵµַʹĿ㴦
			String combinedField = title + (orgName == null ? "" : orgName) + clerkcode + clerkname;
			// ȡм
			Map<String, String> middleTableMap = middleTableData.get(combinedField);
			// middleTableMapΪձʾмΪգʹԭʼݣΪʹм
			if (middleTableMap != null) {
				staffMoney = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("staffsum"))).toString();
				orgMoney = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("orgsum"))).toString();
			} else {
				staffMoney = MathTool.nvl(ValueUtils.getUFDouble(map.get("staffsum"))).toString();
				orgMoney = MathTool.nvl(ValueUtils.getUFDouble(map.get("orgsum"))).toString();
			}
			int staffMoneyLength = staffMoney.substring(staffMoney.indexOf(".") + 1).length();// ˲Сλ
			int orgMoneyLength = orgMoney.substring(orgMoney.indexOf(".") + 1).length();// ˾Сλ
			// ˲ֻ߹˾Сλ2λҪн
			if (staffMoneyLength > 2 || orgMoneyLength > 2) {
				UFDouble beforePsgStaffMoney = new UFDouble(staffMoney);
				UFDouble beforePsgOrgMoney = new UFDouble(orgMoney);
				// ˲ֻ߹˾ִ0.0000,˲ֻ߹˾һ0Ҫн
				if (!MathTool.equals(beforePsgStaffMoney, null) || !MathTool.equals(beforePsgOrgMoney, null)) {
					// ǰclerkcodemapݽ
					if (beforePsgMoney.get(clerkcode) != null) {
						mapMoney = beforePsgMoney.get(clerkcode);
						beforePsgStaffMoney = beforePsgStaffMoney.add(mapMoney.get("beforePsgStaffMoney"));
						beforePsgOrgMoney = beforePsgOrgMoney.add(mapMoney.get("beforePsgOrgMoney"));
					}
					mapMoney.put("beforePsgStaffMoney", beforePsgStaffMoney);
					mapMoney.put("beforePsgOrgMoney", beforePsgOrgMoney);
					beforePsgMoney.put(clerkcode, mapMoney);
				}
			}
		}
	}

	/**
	 * ѯмݲ
	 * 
	 * @return
	 * @throws Exception
	 */
	private void queryMiddleTable() throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" combined_field,basicssum,staffsum,orgsum,mark from accumulation_fund");
		sql.append(" WHERE ");
		sql.append(" tablename = 'ѷ̯' AND combined_field NOT LIKE 'ˣʵʼ˾ѽɵ¹ʸ˲ѿ%'");
		sql.append(" AND orgcode = '" + orgCode + "' AND period = '" + period + "'");
		List<Map<String, String>> listMap = (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
		for (int i = 0; i < listMap.size(); i++) {
			Map<String, String> map = listMap.get(i);
			middleTableData.put(map.get("combined_field"), map);
		}
	}

	/**
	 * ѯ˳е
	 * 
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String, String>> queryTableOne(String orgCode, String period) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" clerkcode,clerkname,endowment_base AS basicssum,0 AS staffsum");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM AS seq,t.CLERKCODE,T1.CLERKNAME,t.ym,sum( nvl( t.VALUE, 0 ) ) AS sum_per_cost,t1.ENDOWMENT_BASE");
		sql.append(" FROM");
		sql.append(" NC6337.v_data_xz_gjjshare t");
		sql.append(" LEFT JOIN NC6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 ON t1.CLERKCODE = t.CLERKCODE AND t1.PAY_MONTH || '-01' = t.ym");
		sql.append(" WHERE");
		sql.append(" t.key = '籣˾˰ۿ' AND t.VALUE <> 0 AND t.ym = '" + period + "' || '-01' AND t1.ORGCODE = '" + orgCode + "'");
		sql.append(" AND t1.ENDOWMENT_BASE IS NOT NULL");
		sql.append(" GROUP BY ROWNUM,t.CLERKCODE,T1.CLERKNAME,t.ym,t1.ENDOWMENT_BASE");
		sql.append(" ORDER BY ROWNUM)");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}

	/**
	 * ѯⲿ˾е
	 * 
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String, String>> queryTableTwo(String orgCode, String period) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT clerkcode,clerkname,endowment_base AS basicssum,AGENCY_MONEY AS orgsum,mark");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM,t.*");
		sql.append(" FROM nc6337.V_SUM_TB_HR_SOCIAL_SECURITY t");
		sql.append(" WHERE");
		sql.append(" t.out_org IS NOT NULL AND t.PAY_MONTH = '" + period + "' AND t.ORGCODE = '" + orgCode + "'");
		sql.append(" ORDER BY ROWNUM)");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}

	/**
	 * ѯųе
	 * 
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String, String>> queryTableThree(String orgCode, String period) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT clerkcode,clerkname,endowment_base AS basicssum,AGENCY_MONEY AS orgsum,mark");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM,t2.*");
		sql.append(" FROM");
		sql.append(" (SELECT T.Endowment_Base,T.CLERKCODE,T.CLERKNAME,T.so_org_sum,T.so_staff_sum,T.ORGCODE,T.PAY_MONTH,");
		sql.append(" T.AGENCY_MONEY,T.MARK");
		sql.append(" FROM");
		sql.append(" NC6337.V_SUM_TB_HR_SOCIAL_SECURITY T");
		sql.append(" WHERE");
		sql.append(" T.PK_POST IN ( SELECT T3.PK_POST FROM NC6337.om_post t3 WHERE T3.postname = 'бԱ' )");
		sql.append(" UNION ALL");
		sql.append(" SELECT t1.Endowment_Base,t1.CLERKCODE,t1.CLERKNAME,t1.so_org_sum,t1.so_staff_sum,T1.ORGCODE,");
		sql.append(" t1.PAY_MONTH,T1.AGENCY_MONEY,T1.MARK");
		sql.append(" FROM");
		sql.append(" NC6337.V_SUM_TB_HR_SOCIAL_SECURITY_D t1");
		sql.append(" WHERE");
		sql.append(" t1.MARK = '') t2");
		sql.append(" WHERE");
		sql.append(" t2.PAY_MONTH = '" + period + "'AND t2.ORGCODE = '" + orgCode + "'");
		sql.append(" ORDER BY ROWNUM)");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}

	/**
	 * ѯ˾е
	 * 
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String, String>> queryTableFour(String orgCode, String period) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT salocation as orgname,clerkcode,clerkname,AGENCY_MONEY AS orgsum ");
		sql.append(" FROM");
		sql.append(" (SELECT");
		sql.append(" t.CLERKCODE, T1.CLERKNAME, t.ym, sum( nvl( t.VALUE, 0 ) ) AS sum_per_cost,");
		sql.append(" T13.Name AS costorgname, T13.Name AS salocation, to_number( t1.AGENCY_MONEY ) AS AGENCY_MONEY");
		sql.append(" FROM NC6337.v_data_xz_gjjshare t");
		sql.append(" LEFT JOIN NC6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 ON t1.CLERKCODE = t.CLERKCODE  AND t1.PAY_MONTH || '-01' = t.ym");
		sql.append(" LEFT JOIN (SELECT t12.CLERK_CODE, t12.NC_PK_POST FROM nc6337.monthly_position_gjj t12");
		sql.append(" WHERE t12.month = to_char( last_day( to_date( '" + period + "', 'yyyy-mm' ) ), 'yyyy-mm-dd' ) ) T12 ON t12.CLERK_CODE = t.CLERKCODE");
		sql.append(" LEFT JOIN nc6337.om_post t14 ON t14.pk_post = t12.NC_PK_POST");
		sql.append(" LEFT JOIN nc6337.org_corp T13 ON T13.Pk_Corp = t14.pk_org");
		sql.append(" WHERE t.key IN ( '籣˺ϼ', 'õ籣', '籣˿ۿ', 'õ籣T' )");
		sql.append(" AND t.ym = '" + period + "' || '-01'  AND t1.ORGCODE = '" + orgCode + "' ");
		sql.append(" AND t.CLERKCODE NOT IN ( SELECT t11.WORKERCODE FROM nc6337.v_hr_allocationratio_gjjshareF t11 WHERE t11.WA_PERIOD = '" + period + "' || '-01' ) ");
		sql.append(" AND t1.CLERKNAME <> ''  AND t14.PK_POST NOT IN ( SELECT T3.PK_POST FROM NC6337.om_post t3 WHERE T3.postname = 'бԱ' ) ");
		sql.append(" GROUP BY t.CLERKCODE, T1.CLERKNAME, t.ym, t1.AGENCY_MONEY, T13.Name UNION ALL");
		sql.append(" SELECT t.WORKERCODE AS CLERKCODE, t1.CLERKNAME, t.WA_PERIOD AS ym, 0 AS sum_per_cost, T6.NAME AS costorgname, 'Ϻ컪' AS salocation,");
		sql.append(" round( nvl( t1.AGENCY_MONEY, 0 ) * nvl( t.perc, 0 ), 3 ) AS AGENCY_MONEY ");
		sql.append(" FROM nc6337.v_hr_allocationratio_gjjshareF t");
		sql.append(" LEFT JOIN nc6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 ON t1.CLERKCODE = t.WORKERCODE ");
		sql.append(" AND t1.PAY_MONTH || '-01' = t.WA_PERIOD");
		sql.append(" LEFT JOIN ( SELECT DISTINCT T5.CODE, T5.NAME, t5.pk_corp FROM nc6337.ORG_CORP T5 ) T6 ON T6.pk_corp = T.COST_ORG ");
		sql.append(" WHERE t.WA_PERIOD = '" + period + "' || '-01'  AND t1.CLERKNAME IS NOT NULL  AND t1.ORGCODE = '" + orgCode + "' UNION ALL");
		sql.append(" SELECT t1.CLERKCODE, t1.CLERKNAME, t1.PAY_MONTH || '-01' AS ym, 0 AS sum_per_cost, T1.PAY_SOS_ORG AS costorgname,");
		sql.append(" 'Ϻ컪' AS salocation, to_number( t1.AGENCY_MONEY ) AS AGENCY_MONEY ");
		sql.append(" FROM NC6337.V_SUM_TB_HR_SOCIAL_SECURITY_D t1 ");
		sql.append(" WHERE t1.MARK IN ( 'Ա', 'Ϻ˾е' )  AND t1.PAY_MONTH = '" + period + "'  AND t1.ORGCODE = '" + orgCode + "') ORDER BY orgname");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}

	/**
	 * ѯʵʽ
	 * 
	 * @param period
	 * @param orgCode
	 * @return
	 * @throws Exception
	 */
	private Map<String, String> queryTableTen(String orgCode, String period) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" *");
		sql.append(" FROM");
		sql.append(" NC6337.V_SUM_TB_HR_SOCIAL_SECURITY_D T");
		sql.append(" WHERE");
		sql.append(" T.CLERKNAME = '' AND T.PAY_MONTH = '" + period + "' AND T.ORGCODE = '" + orgCode + "'");
		Map<String, String> map = (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
		if (map == null) {
			map = new HashMap<String, String>();
			map.put("so_staff_sum", null);
			map.put("so_org_sum", null);
			map.put("agency_money", null);
		}
		return map;
	}

	/**
	 * ObjectתUFDoubleñλС
	 * 
	 * @param obj
	 * @param power
	 * @return
	 */
	public UFDouble nvl(Object obj, int power) {
		return MathTool.nvl(ValueUtils.getUFDouble(obj)).setScale(2, UFDouble.ROUND_HALF_UP);
	}

	private void update(UITablePane table) {
		try {
			List<Object[]> selectedData = new ArrayList<Object[]>();
			int rows[] = table.getTable().getSelectedRows();
			if (rows.length == 0) {
				MessageDialog.showHintDlg(this, "ʾ", "ѡҪ޸ĵݣ");
				return;
			} else {
				for (int i = 0; i < rows.length; i++) {
					// С֯ͱΪ8λ
					Object[] rowData = new Object[8];
					for (int j = 0; j < 8; j++) {
						Object obj = table.getTable().getValueAt(rows[i], 7);
						if (obj == null) {
							MessageDialog.showHintDlg(this, "ʾ", "ѡȷ޸ģ");
							return;
						}
						rowData[j] = table.getTable().getValueAt(rows[i], j);
					}
					selectedData.add(rowData);
				}
			}
			// 0ʾʵ޸ģǵر
			if (new ServiceChargeAllUpdateDialog(selectedData, orgCode, period).showModal() == 0) {
				// ˢ
				TableProcessing();
				MessageDialog.showHintDlg(this, "ʾ", "޸ĳɹ");
			}
		} catch (Exception e) {
			MessageDialog.showHintDlg(this, "ʾ", e.getMessage());
		}
	}

	/**
	 * 
	 */
	private void onoutput() {
		OutputDialogUtil outdig = new OutputDialogUtil(this, getTablePanel(), "ѷ̯");
		if (outdig.showModal() == 2) {
			return;
		}
	}

	/**
	 * װƾ֤
	 * 
	 * @param tablepane
	 */
	private Map<String, UFDouble> getVoucherAmount(UITablePane tablepane) {
		Map<String, UFDouble> map = new LinkedHashMap<String, UFDouble>();
		// һ ˳е-˾ֺϼ
		Object objgs = tablepane.getTable().getValueAt(2, 2);
		// һ ˳е-˲ֺϼ
		Object objgr = tablepane.getTable().getValueAt(3, 2);
		//  ⲿ˾е-˾ֺϼ
		Object objwbgs = tablepane.getTable().getValueAt(2, 5);
		//  ųе-˾ֺϼ
		Object objbmgs = tablepane.getTable().getValueAt(2, 8);
		//  ˾е-˾ֺϼ
		Object objgsgs = tablepane.getTable().getValueAt(4, 2);
		// ѷ̯
		Object objsibco = tablepane.getTable().getValueAt(1, 3);

		/** 跽Ӧտ//ϸ **/
		// =һ(ɸ˳е) ˾Žϼ K10
		UFDouble grcmpamount = objgs == null ? UFDouble.ZERO_DBL : new UFDouble(objgs.toString());

		/** 跽Ӧ˿/Ԥɱ/칫/ţӦ Ŀ Ŀרҵ漰 **/
		// =(ɲųе) ˾ֽϼ K11
		UFDouble bmcmpamount = objbmgs == null ? UFDouble.ZERO_DBL : new UFDouble(objbmgs.toString());

		/** 跽Ӧտ/λ/Ӧ˾-Ϻѯ޹˾ ע̺˹ģӽ---Ϻѯ޹˾ --- ϺޥͶʹ޹˾ **/
		// ֻ1ˣӽܣдĬֵԱٽŻ
		// =(ⲿ˾е) ˾ֽϼ K12
		UFDouble bcmpamount = objwbgs == null ? UFDouble.ZERO_DBL : new UFDouble(objwbgs.toString());

		/** 跽/칫/ţ **/
		UFDouble cmpamount = objgsgs == null ? UFDouble.ZERO_DBL : new UFDouble(objgsgs.toString());
		// 
		// UFDouble jscmpamout = cmpamount.div(new UFDouble("1.05")).sub(grcmpamount.multiply(new UFDouble("1.05"))).sub(bmcmpamount.div(new UFDouble("1.05")).multiply(new UFDouble("0.05")))
		// .sub(bcmpamount.div(new UFDouble("1.05")).multiply(new UFDouble("0.05"))).setScale(2, UFDouble.ROUND_HALF_UP);
		UFDouble jscmpamout = cmpamount.add(bmcmpamount);

		/** : Ӧ˿/ʵӦ/Ϻҵѯ޹˾ **/
		// =ѷ̯
		UFDouble jsibcomount = objsibco == null ? UFDouble.ZERO_DBL : new UFDouble(objsibco.toString());

		/** 跽Ӧ˰/Ӧֵ˰/˰/ֿ֤ **/
		// =-跽
		// UFDouble yjsamount = jsibcomount.sub(grcmpamount.add(bmcmpamount).add(bcmpamount).add(jscmpamout));

		map.put("/칫", jscmpamout);
		map.put("Ӧտ/", grcmpamount);
		map.put("Ӧ˿/Ԥɱ/칫", bmcmpamount);
		map.put("Ӧտ/λ", bcmpamount);
		// map.put("Ӧ˰", yjsamount);
		map.put("Ԥ˿/", jsibcomount);
		return map;
	}

	// ƾ֤װ
	public VoucherVO getVoucherVO(Map<String, UFDouble> map) throws Exception {
		VoucherVO voucher = new VoucherVO();
		String pk_org = getPk_financeorg(orgCode);
		// ֯汾
		String pk_group = InvocationInfoProxy.getInstance().getGroupId();// 
		String yearperiod = period.substring(0, 4);//       2025-03-13
		String monthperiod = period.substring(5, 7);// ·    2025-03-13
		Date newDate = convertStringToDate(period + "-01", "yyyy-MM-dd");
		String nexMonthDate = getMonthFirstDate(newDate);// һ
		String year = nexMonthDate.substring(0, 4);// 
		String month = nexMonthDate.substring(5, 7);// ·
		String pk_user = InvocationInfoProxy.getInstance().getUserId();// Ƶ
		// String pk_user = getpk_user("XTPZ000101");//Ƶ
		String pk_accountGlbook = tran_accountingbook(pk_org);// ˲
		String pk_vouchertype = vouchertypeGetCode("03");// ƾ֤03;
		String pk_org_v = getPkorgv(pk_org);
		voucher.setPk_vouchertype(pk_vouchertype);// ƾ֤
		voucher.setAttachment(0);
		voucher.setDetailmodflag(UFBoolean.TRUE);
		voucher.setDiscardflag(UFBoolean.FALSE);
		voucher.setIsdifflag(UFBoolean.FALSE);
		voucher.setPeriod(month);// ·
		voucher.setPk_manager("N/A");
		voucher.setPk_prepared(pk_user);
		voucher.setCreator(pk_user);
		voucher.setPk_system("GJ");// Դϵͳ籣𣩣ֹ
		// voucher.setPrepareddate(new UFDate(period+"-30"));//ƾ֤
		if ("02".equals(month)) {
			voucher.setPrepareddate(new UFDate(nexMonthDate));// ƾ֤
		} else {
			voucher.setPrepareddate(new UFDate(nexMonthDate));// ƾ֤
		}
		voucher.setSignflag(UFBoolean.TRUE);
		voucher.setVoucherkind(0);
		voucher.setYear(year);// 
		voucher.setPk_org(pk_org);
		voucher.setPk_org_v(pk_org_v);
		voucher.setPk_group(pk_group);
		voucher.setPk_accountingbook(pk_accountGlbook);
		ArrayList<DetailVO> itemarr = new ArrayList<DetailVO>();
		for (Entry<String, UFDouble> entry : map.entrySet()) {
			String key = entry.getKey();
			String km_code = "";
			UFDouble creditamount = UFDouble.ZERO_DBL;
			UFDouble debitamount = UFDouble.ZERO_DBL;
			String pk_accasoa = "";
			if ("/칫".equals(key)) {
				km_code = "660209";// /칫
				debitamount = entry.getValue();// 跽
				pk_accasoa = tranKm(km_code, pk_accountGlbook);// Ŀ
				DetailVO itemVO = new DetailVO();
				getDetailvo(itemVO, pk_accasoa, creditamount, debitamount, voucher,  "" + yearperiod + "" + monthperiod + " ´");
				// 
				AssVO[] assvos = getAss(pk_accasoa, "0001", "-⣨ɱᣩ", pk_org);// ţ
				ArrayList<AssVO> arrassvo = new ArrayList<AssVO>();
				arrassvo.add(assvos[0]);
				itemVO.setAss((AssVO[]) arrassvo.toArray(new AssVO[0]));
				itemarr.add(itemVO);
			} else if ("Ӧտ/".equals(key)) {
				km_code = "122102";// Ӧտ/
				debitamount = entry.getValue();// 跽
				pk_accasoa = tranKm(km_code, pk_accountGlbook);// Ŀ
				// ѯһԱϸ
				List<String> ycode = querygcode(orgCode, period);
				for (int i = 0; i < ycode.size(); i++) {
					DetailVO itemVO = new DetailVO();
					getDetailvo(itemVO, pk_accasoa, creditamount, debitamount, voucher, "̯");
					// 
					AssVO[] assvos = getAss(pk_accasoa, "0002", psndocCode(ycode.get(i)), pk_org);// Ա
					ArrayList<AssVO> arrassvo = new ArrayList<AssVO>();
					arrassvo.add(assvos[0]);
					itemVO.setAss((AssVO[]) arrassvo.toArray(new AssVO[0]));
					// itemarr.add(itemVO);
				}
			} else if ("Ӧ˿/Ԥɱ/칫".equals(key)) {
				km_code = "22020205";// Ӧ˿/Ԥɱ/칫
				debitamount = entry.getValue();// 跽
				pk_accasoa = tranKm(km_code, pk_accountGlbook);// Ŀ
				DetailVO itemVO = new DetailVO();
				getDetailvo(itemVO, pk_accasoa, creditamount, debitamount, voucher,  "" + yearperiod + "" + monthperiod + " ´");
				// 
				AssVO[] assvos1 = getAss(pk_accasoa, "0001", "-⣨ɱᣩ", pk_org);// ţ
				AssVO[] assvos = getAss(pk_accasoa, "0010", "PM201601130001", pk_org);// Ŀ
				AssVO[] assvos2 = getAss(pk_accasoa, "0043", "99", pk_org);// Ŀרҵ漰
				ArrayList<AssVO> arrassvo = new ArrayList<AssVO>();
				arrassvo.add(assvos[0]);
				arrassvo.add(assvos1[0]);
				arrassvo.add(assvos2[0]);
				itemVO.setAss((AssVO[]) arrassvo.toArray(new AssVO[0]));
				// itemarr.add(itemVO);// ɲȫɣ˲е̯
			} else if ("Ӧտ/λ".equals(key)) {
				km_code = "122101";// Ӧտ/λ
				debitamount = entry.getValue();// 跽
				if(debitamount.doubleValue() != 0){// жⲿ˾е˾ǷΪ0(ӽ⴦)
					pk_accasoa = tranKm(km_code, pk_accountGlbook);// Ŀ
					DetailVO itemVO = new DetailVO();
					getDetailvo(itemVO, pk_accasoa, creditamount, debitamount, voucher,  "" + yearperiod + "" + monthperiod + " ´-ӽ");
					// 㣺Ϻѯ޹˾
					AssVO[] assvos = getAss(pk_accasoa, "0004", "G006353", pk_org);// 
					ArrayList<AssVO> arrassvo = new ArrayList<AssVO>();
					arrassvo.add(assvos[0]);
					itemVO.setAss((AssVO[]) arrassvo.toArray(new AssVO[0]));
					itemarr.add(itemVO);	
				}
				
			}
			// else if("Ӧ˰".equals(key)){
			// km_code= "2221010101";//Ӧ˰/Ӧֵ˰/˰/ֿ֤
			// debitamount = entry.getValue();//跽
			// pk_accasoa= tranKm(km_code, pk_accountGlbook);//Ŀ
			// DetailVO itemVO = new DetailVO();
			// getDetailvo(itemVO, pk_accasoa, creditamount, debitamount, voucher, period+"´");
			// itemarr.add(itemVO);
			else if ("Ԥ˿/".equals(key)) {
				// km_code= "220201";
				km_code = "112301";// Ԥ˿/̯
				creditamount = entry.getValue();// 
				pk_accasoa = tranKm(km_code, pk_accountGlbook);// Ŀ
				DetailVO itemVO = new DetailVO();
				getDetailvo(itemVO, pk_accasoa, creditamount, debitamount, voucher,  "" + yearperiod + "" + monthperiod + " ´");
				// 
				AssVO[] assvos = getAss(pk_accasoa, "05", "11", pk_org);// ̯´̯
				// AssVO[] assvos = getAss(pk_accasoa, "0004","G000371",pk_org);//̣Ϻҵѯ޹˾
				// AssVO[] assvos1 = getAss(pk_accasoa, "X01","1122",pk_org);//ֽ
				ArrayList<AssVO> arrassvo = new ArrayList<AssVO>();
				arrassvo.add(assvos[0]);
				// arrassvo.add(assvos1[0]);
				itemVO.setAss((AssVO[]) arrassvo.toArray(new AssVO[0]));
				itemarr.add(itemVO);
			}
		}
		voucher.setDetails((DetailVO[]) itemarr.toArray(new DetailVO[0]));
		return voucher;
	}

	private DetailVO getDetailvo(DetailVO itemVO, String pk_accasoa, UFDouble creditamount, UFDouble debitamount, VoucherVO voucher, String explanation) throws BusinessException {
		String pk_currtype = getcurrtype("CNY");// 
		itemVO.setPk_accasoa(pk_accasoa);// ƿĿ
		itemVO.setCreditamount(creditamount);// 
		itemVO.setCreditquantity(UFDouble.ZERO_DBL);// 
		itemVO.setDebitamount(debitamount);// 跽
		itemVO.setDirection("D");// 
		itemVO.setDebitquantity(UFDouble.ZERO_DBL);
		// itemVO.setDetailindex(Integer.parseInt(detailno));
		itemVO.setDiscardflag(UFBoolean.FALSE);
		itemVO.setExcrate1(UFDouble.ZERO_DBL);
		itemVO.setExcrate2(UFDouble.ONE_DBL);
		itemVO.setExplanation(explanation);// ժҪ
		voucher.setExplanation(explanation);// ժҪ
		itemVO.setFraccreditamount(UFDouble.ZERO_DBL);
		itemVO.setFracdebitamount(UFDouble.ZERO_DBL);
		itemVO.setIsdifflag(UFBoolean.FALSE);
		itemVO.setLocalcreditamount(itemVO.getCreditamount());// ȫִ
		itemVO.setLocaldebitamount(itemVO.getDebitamount());// 跽
		itemVO.setPeriod(voucher.getPeriod());// ڼ
		itemVO.setPk_manager(voucher.getPk_manager());
		itemVO.setPk_system(voucher.getPk_system());
		itemVO.setPk_vouchertype(voucher.getPk_vouchertype());// ƾ֤
		itemVO.setPrepareddate(voucher.getPrepareddate());
		itemVO.setPrice(UFDouble.ZERO_DBL);
		itemVO.setVoucherkind(0);// ƾ֤
		itemVO.setYear(voucher.getYear());
		itemVO.setPk_org(voucher.getPk_org());
		itemVO.setPk_org(voucher.getPk_org());
		itemVO.setPk_org_v(voucher.getPk_org_v());
		itemVO.setPk_group(voucher.getPk_group());
		itemVO.setPk_accountingbook(voucher.getPk_accountingbook());
		itemVO.setPk_unit(voucher.getPk_org());
		itemVO.setPk_unit_v(voucher.getPk_org_v());
		itemVO.setPk_currtype(pk_currtype);// 
		return itemVO;
	}

	private AssVO[] getAss(String pk_km, String code1, String pk_checkvalue1, String pk_org) throws ClassNotFoundException, BusinessException {
		ArrayList zrr = new ArrayList();
		String sql = "select c.pk_accasoa,\n" + "       c.pk_accchart,\n" + "       c.pk_account,\n" + "       c.name,\n" + "       c.dispname,\n" + "       a.refnodename,\n" + "\n"
				+ "       a.code,\n" + "       a.name,\n" + "       a.refnodename,\n" + "       m.defaulttablename,\n" + "       m.id,\n" + "       a.  pk_accassitem  ,  m.fullclassname  "
				+ "  from bd_accassitem a, bd_accass b, bd_accasoa c, md_class m\n" + " where a.classid = m.id\n" + "   and a.pk_accassitem = b.pk_entity\n" + "   and b.pk_accasoa = c.pk_accasoa\n"
				+ "  and  c.pk_accasoa  = '" + pk_km + "' ";
		if (code1 != null) {
			sql += "  and   a.code = '" + code1 + "'  ";
		}
		;
		// ѯĿӦĸ
		ArrayList ass_arr = (ArrayList) iuap.executeQuery(sql, new MapListProcessor());
		if (ass_arr != null) {
			for (int j = 0; j < ass_arr.size(); j++) {
				HashMap assmap = (HashMap) ass_arr.get(j);
				String getRefnodename = assmap.get("refnodename") + "";
				String fullclassname = assmap.get("fullclassname") + "";
				SuperVO refvo = initSuperVOClass(Class.forName(fullclassname));
				String qrykey = "code";
				if ("Ŀ".equals(getRefnodename)) {
					qrykey = "project_code";
				} else if ("".equals(getRefnodename)) {
					qrykey = "name";
				}
				String refsql = "select * from   " + refvo.getTableName() + " where  nvl(dr,0) = 0   and ( " + qrykey + "  ='" + pk_checkvalue1 + "'  or " + refvo.getPKFieldName() + " = '"
						+ pk_checkvalue1 + "' )";
				if (refvo.getTableName().equals("org_dept")) {
					refsql = "select * from   " + refvo.getTableName() + " where  nvl(dr,0) = 0  and   pk_org  = '" + pk_org + "'  and ( " + qrykey + "  ='" + pk_checkvalue1 + "'  or "
							+ refvo.getPKFieldName() + " = '" + pk_checkvalue1 + "' )";
				} else if (refvo.getTableName().equals("bd_defdoc")) {

					if ("˾ڲרҵ(Զ嵵)".equals(getRefnodename)) {
						refsql = "select * from   " + refvo.getTableName() + " where  nvl(dr,0) = 0  and  ( " + qrykey + "  ='" + pk_checkvalue1 + "'  or " + refvo.getPKFieldName() + " = '"
								+ pk_checkvalue1 + "' )  " + "and  pk_defdoclist =(select pk_defdoclist from  bd_defdoclist  where   code = 'HR016' )     ";
					} else if ("ֽ(Զ嵵)".equals(getRefnodename)) {
						refsql = "select * from   " + refvo.getTableName() + " where  nvl(dr,0) = 0  and  ( " + qrykey + "  ='" + pk_checkvalue1 + "'  or " + refvo.getPKFieldName() + " = '"
								+ pk_checkvalue1 + "' )  " + "and  pk_defdoclist =(select pk_defdoclist from  bd_defdoclist  where   code ='X01')     ";
					} else if ("̯(Զ嵵)".equals(getRefnodename)) {
						refsql = "select * from   " + refvo.getTableName() + " where  nvl(dr,0) = 0  and  ( " + qrykey + "  ='" + pk_checkvalue1 + "'  or " + refvo.getPKFieldName() + " = '"
								+ pk_checkvalue1 + "' )  " + "and  pk_defdoclist =(select pk_defdoclist from  bd_defdoclist  where   code = '14' )     ";
					}
				}
				SuperVO dataVO = (SuperVO) iuap.executeQuery(refsql, new BeanProcessor(Class.forName(fullclassname)));
				if (dataVO == null) {
					throw new BusinessException("㷭ʧܣ" + pk_checkvalue1);
				}
				AssVO tempAss = new AssVO();
				String pk_checkvalue = dataVO.getPrimaryKey();
				String code = "";
				if ("Ŀ".equals(getRefnodename)) {
					code = dataVO.getAttributeValue("project_code") + "";
				} else {
					code = dataVO.getAttributeValue("code") + "";
				}
				if ("".equals(getRefnodename)) {
					// ˵ǻֱͣӵַ
					tempAss.setPk_Checkvalue(code);
					tempAss.setPk_Checktype(assmap.get("pk_accassitem") + "");
					tempAss.setChecktypecode(assmap.get("code") + "");
					tempAss.setChecktypename(assmap.get("name") + "");
				} else {
					tempAss.setPk_Checktype(assmap.get("pk_accassitem") + "");
					tempAss.setChecktypecode(assmap.get("code") + "");
					tempAss.setChecktypename(assmap.get("name") + "");
					if ("Ŀ".equals(getRefnodename)) {
						tempAss.setCheckvaluename(dataVO.getAttributeValue("project_name") + "");
					} else {
						tempAss.setCheckvaluename(dataVO.getAttributeValue("name") + "");
					}
					tempAss.setPk_Checkvalue(pk_checkvalue);
					tempAss.setCheckvaluecode(code);
				}
				if (tempAss != null && "".equals(tempAss.getPk_Checkvalue())) {
					throw new BusinessException("㷭ʧܣ" + code);
				}
				zrr.add(tempAss);
			}
		} else {
			return null;
		}
		return (AssVO[]) zrr.toArray(new AssVO[0]);
	}

	private SuperVO initSuperVOClass(Class className) {
		Object vo;
		try {
			vo = className.newInstance();
		} catch (InstantiationException e) {
			throw new IllegalArgumentException("Parameter Class can not be instantiated!!");
		} catch (IllegalAccessException e) {
			throw new IllegalArgumentException(" Illegal Parameter!!");
		}
		if (!(vo instanceof SuperVO))
			throw new IllegalArgumentException("Parameter Class is not SuperVO");
		return (SuperVO) vo;
	}

	/**
	 * 
	 * 
	 * @param pk_org
	 * @return
	 * @throws BusinessException
	 * @throws DAOException
	 */
	private String getcurrtype(String code) throws BusinessException {
		String sql = "select      pk_currtype   from  bd_currtype  where    code   = ? and nvl(dr,0) = 0 ";
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(code);
		Object pk_currtype = iuap.executeQuery(sql, parameter, new ColumnProcessor());
		return pk_currtype != null ? pk_currtype + "" : "";
	}

	/**
	 * ˲
	 * 
	 * @throws BusinessException
	 * @throws DAOException
	 */
	private String tran_accountingbook(String pk_org) throws BusinessException {
		String sql = "select   pk_accountingbook  from  org_accountingbook  where    pk_relorg   = ? and nvl(dr,0) = 0 ";
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(pk_org);
		Object pk_vouchertype = iuap.executeQuery(sql, parameter, new ColumnProcessor());
		return pk_vouchertype != null ? pk_vouchertype + "" : "";
	}

	/**
	 * ƾ֤
	 * 
	 * @param pk
	 * @return
	 * @throws DAOException
	 * @throws BusinessException
	 */
	private String vouchertypeGetCode(String pk) throws BusinessException {
		String sql = "select  pk_vouchertype     from  bd_vouchertype  where  code   = ? and nvl(dr,0) = 0 ";
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(pk);
		Object pk_vouchertype = iuap.executeQuery(sql, parameter, new ColumnProcessor());
		return pk_vouchertype != null ? pk_vouchertype + "" : "";

	}

	/**
	 * ֯汾
	 */
	private String getPkorgv(String pk) throws BusinessException {
		String sql = "select   pk_vid    from  org_financeorg_v  where   pk_financeorg    = ? and nvl(dr,0) = 0 ";
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(pk);
		Object pk_vid = iuap.executeQuery(sql, parameter, new ColumnProcessor());
		return pk_vid != null ? pk_vid + "" : "";
	}

	/**
	 * Ŀ뷭
	 * 
	 * @throws BusinessException
	 * @throws DAOException
	 */
	private String tranKm(String km_code, String pk_accountingbook) throws BusinessException {
		String sql = "select bd_accasoa.pk_accasoa\n" + "  from bd_accasoa bd_accasoa\n" + " inner join bd_account\n" + "    on bd_accasoa.pk_account = bd_account.pk_account\n" + " where 11 = 11\n"
				+ "   and ((bd_accasoa.enablestate = 1 or bd_accasoa.enablestate = 2 or\n" + "       bd_accasoa.enablestate = 3))\n" + "   and bd_account.code = ?\n"
				+ "   and bd_accasoa.pk_accchart =\n" + "       (select pk_accchart\n" + "           from bd_accchart\n" + "          where  originalchart =\n"
				+ "                 (select pk_curraccchart\n" + "                    from org_accountingbook\n" + "                   where pk_accountingbook = ? and alterchart <> '~' and\n"
				+ "           tempversionflag <> 'Y'));";

		SQLParameter parameter = new SQLParameter();
		parameter.addParam(km_code);
		parameter.addParam(pk_accountingbook);
		Object pk_accasoa = (String) iuap.executeQuery(sql, parameter, new ColumnProcessor());
		return pk_accasoa != null ? pk_accasoa + "" : "";
	}

	// ѯһԱ
	private List<String> querygcode(String orgCode, String period) throws Exception {
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" clerkcode ");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM AS seq,t.CLERKCODE,T1.CLERKNAME,t.ym,sum( nvl( t.VALUE, 0 ) ) AS sum_per_cost,t1.ENDOWMENT_BASE");
		sql.append(" FROM");
		sql.append(" NC6337.v_data_xz_gjjshare t");
		sql.append(" LEFT JOIN NC6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 ON t1.CLERKCODE = t.CLERKCODE AND t1.PAY_MONTH || '-01' = t.ym");
		sql.append(" WHERE");
		sql.append(" t.key = '籣˾˰ۿ' AND t.VALUE <> 0 AND t.ym = '" + period + "' || '-01' AND t1.ORGCODE = '" + orgCode + "'");
		sql.append(" AND t1.ENDOWMENT_BASE IS NOT NULL");
		sql.append(" GROUP BY ROWNUM,t.CLERKCODE,T1.CLERKNAME,t.ym,t1.ENDOWMENT_BASE");
		sql.append(" ORDER BY ROWNUM)");
		return (List<String>) iuap.executeQuery(sql.toString(), new ColumnListProcessor());
	}

	// ԱŲѯԱ
	private String psndocCode(String clerkcode) throws BusinessException {
		String sql = "select bd_psndoc.code from  hi_psnjob " + "inner join bd_psndoc on bd_psndoc.pk_psndoc=hi_psnjob.pk_psndoc " + "and nvl(hi_psnjob.dr,0)=0 and nvl(bd_psndoc.dr,0)=0 "
				+ "and hi_psnjob.clerkcode='" + clerkcode + "'  ";
		Object code = (String) iuap.executeQuery(sql, new ColumnProcessor());
		return code != null ? code + "" : "";
	}

	private String getPk_financeorg(String code) throws BusinessException {
		String sql = "select pk_financeorg  from  org_financeorg  where code='" + code + "' and nvl(dr,0)=0 and enablestate ='2' ";
		Object pk_financeorg = (String) iuap.executeQuery(sql, new ColumnProcessor());
		return pk_financeorg != null ? pk_financeorg + "" : "";
	}

	private String getpk_user(String code) throws BusinessException {
		String sql = "select cuserid   from  sm_user  where user_code='" + code + "' and nvl(dr,0)=0 and enablestate ='2' ";
		Object cuserid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		return cuserid != null ? cuserid + "" : "";
	}

	// ڸʽתַ
	private String getMonthFirstDate(Date date) {
		Calendar calendar = new GregorianCalendar();
		calendar.setTime(date);
		calendar.add(Calendar.MONTH, 1);
		calendar.set(Calendar.DAY_OF_MONTH, calendar.getActualMaximum(Calendar.DAY_OF_MONTH));
		Date first = calendar.getTime();
		return convertDateToString(first, "yyyy-MM-dd");
	}

	// ȡ¸һ
	private String convertDateToString(Date inDate, String dateFormat) {
		String resultValue = "";
		if (inDate == null) {
			return resultValue;
		}
		try {
			SimpleDateFormat df = new SimpleDateFormat(dateFormat == null ? "yyyy-MM-dd" : dateFormat, Locale.US);
			resultValue = df.format(inDate);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return resultValue;
	}

	// ַתڸʽ
	private Date convertStringToDate(String inDate, String format) {
		if (inDate == null || inDate.isEmpty()) {
			return null;
		}
		SimpleDateFormat df;
		Date resultDate = null;
		try {
			df = new SimpleDateFormat(format == null ? "yyyy-MM-dd" : format, Locale.US);
			df.setLenient(false);
			resultDate = df.parse(inDate);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return resultDate;
	}
}
