package nc.hr.utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.joda.time.LocalDate;

import com.alibaba.fastjson.JSONObject;

import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class SpecialDataUtil {

	private static String url = "https://autoaccount.thape.com.cn/nc/vacation/workAndLeaveDays";
	/**
	 *ȡʼ-ڵ·ݲƴӳsql
	 * @param start  ʼ
	 * @param stop	
	 * @return
	 */
	public static String getDateIntervalsql(String str,Date startDate,Date endDate){

		// ʼڵ Calendar ʵ  
        Calendar startCal = Calendar.getInstance();  
        startCal.setTime(startDate);  
  
        // ڵ Calendar ʵʼڿʼ  
        Calendar currentCal = Calendar.getInstance();  
        currentCal.setTime(startDate);  
  
        // ڹ SQL IN Ӿ StringBuffer  
        StringBuffer sqlin = new StringBuffer();  
        sqlin.append(" in (");  
  
        // ѭֱǰڳ  
        while (currentCal.getTime().before(endDate) || currentCal.getTime().equals(endDate)) {  
            // ȡݺ·ݣ·Ҫ +1Ϊ Calendar ·Ǵ 0 ʼģ  
            int year = currentCal.get(Calendar.YEAR);  
            int month = currentCal.get(Calendar.MONTH) + 1;  
	            if(str.equals("N") && year != 2022) {
	            	  // ʽݺ·ΪַYYYY-MM  
		            String yearMonthStr = String.format("%04d%02d", year, month);  
		            sqlin.append("'" + yearMonthStr + "',");  
	            }
	            if(str.equals("Y") && year == 2022) {
	            	  // ʽݺ·ΪַYYYY-MM  
		            String yearMonthStr = String.format("%04d%02d", year, month);  
		            sqlin.append("'" + yearMonthStr + "',");  
	            }
	            // ǰΪһµĵһ  
	            currentCal.add(Calendar.MONTH, 1);  
	            currentCal.set(Calendar.DAY_OF_MONTH, 1);  
	            
        }  
        if(sqlin.substring(sqlin.length()-1).equals("(")) {
        	sqlin.append("'1111'");
        }else {
        	sqlin.deleteCharAt(sqlin.length() - 1); // ɾĶ  
        }
       
        sqlin.append(")");  
		return sqlin.toString();
	}
	
	
	/**
	 *ȡʼ-м·
	 * @param start  ʼ
	 * @param stop	
	 * @return
	 */
	public static List<String> getDateInterval(Date startDate,Date endDate){

	       Calendar startCal = Calendar.getInstance();  
	        startCal.setTime(startDate);  
	  
	        // ڵ Calendar ʵʼڿʼ  
	        Calendar currentCal = Calendar.getInstance();  
	        currentCal.setTime(startDate);  
	  
	        List<String> list = new ArrayList<String>();
	        // ѭֱǰڳ  
	        while (currentCal.getTime().before(endDate) || currentCal.getTime().equals(endDate)) {  
	            // ȡݺ·ݣ·Ҫ +1Ϊ Calendar ·Ǵ 0 ʼģ  
	            int year = currentCal.get(Calendar.YEAR);  
	            int month = currentCal.get(Calendar.MONTH) + 1;
	  
	            // ʽݺ·ΪַYYYYMM  
	            String yearMonthStr = String.format("%04d%02d", year, month);  
	            String formattedStr = yearMonthStr.replaceFirst("^(\\d{4})(\\d{2})", "$1-$2");
	            list.add(formattedStr);  
	            // ǰΪһµĵһ  
	            currentCal.add(Calendar.MONTH, 1);  
	            currentCal.set(Calendar.DAY_OF_MONTH, 1);  
	        }   
			return list;
	}
	
	/**
	 *ȡʼ-ںʼڽм
	 * @param start  ʼ
	 * @param stop	
	 * @return
	 */
	public static String[] GetYears(Date startDate,Date endDate) {
		
		Calendar startCal = Calendar.getInstance();
        startCal.setTime(startDate);
        int startYear = startCal.get(Calendar.YEAR);

        Calendar endCal = Calendar.getInstance();
        endCal.setTime(endDate);
        int endYear = endCal.get(Calendar.YEAR);

        ArrayList<String> yearList = new ArrayList<String>();
        for (int year = startYear; year <= endYear; year++) {
            yearList.add(String.valueOf(year));
        }

        return yearList.toArray(new String[0]);
		
	}
	
	/**
	 * 
	 * @param begindate ʼ
	 * @param enddate 
	 * @param pk_psndoc Աid
	 * @return
	 * @throws Exception
	 */
	public static JSONObject getWorkDays(String begindate,String enddate,String pk_psndoc) throws Exception {
		return JSONObject.parseObject(new HttpHelper().doGet(url+"?begindate="+begindate.toString().subSequence(0, 10)+"&enddate="+enddate.toString().subSequence(0, 10)+"&pk_psndoc="+pk_psndoc+""));
	}
	
	/**
	 * 
	 * @param begindate ʼ
	 * @param enddate 
	 * @param pk_psndoc Աid
	 * @return
	 * @throws Exception
	 */
//	public static JSONObject getWorkDaysn(LocalDate begindate,LocalDate enddate,String pk_psndoc) throws Exception {
//		JSONObject jsonObject = JSONObject.parseObject(new HttpHelper().doGet(url+"?begindate="+begindate.toString().subSequence(0, 10)+"&enddate="+enddate.toString().subSequence(0, 10)+"&pk_psndoc="+pk_psndoc+""));
//		if(!"1".equals(jsonObject.getString("code"))) {
//        	ExceptionUtils.wrappBusinessException("ȡʧ:"+jsonObject.get("msg"));
//        }
//		return jsonObject;
//	}
	public static JSONObject getWorkDaysn(Date begindate,Date enddate,String pk_psndoc) throws Exception {
		JSONObject jsonObject = JSONObject.parseObject(new HttpHelper().doGet(url+"?begindate="+formatDate(begindate)+"&enddate="+formatDate(enddate)+"&pk_psndoc="+pk_psndoc+""));
		if(!"1".equals(jsonObject.getString("code"))) {
        	ExceptionUtils.wrappBusinessException("ȡʧ:"+jsonObject.get("msg"));
        }
		return jsonObject;
	}

	
	/**
	 * 
	 * @param workPeriodStart ڿʼ
	 * @param workPeriodEnd ڽ
	 * @param minimumPeriodStart ѷʼ
	 * @param minimumPeriodEnd ѷ
	 * @param pk_psndoc Աid
	 * @return ںͱнĹ
	 * @throws Exception
	 */
//	public static String DateIntersection(Date workPeriodStart,Date workPeriodEnd,LocalDate minimumPeriodStart,LocalDate minimumPeriodEnd,String pk_psndoc)throws Exception {
//		if (minimumPeriodStart.isAfter(workPeriodEnd) || minimumPeriodEnd.isBefore(workPeriodStart)) {
//            return "0";
//        } else {
//            LocalDate intersectionStart = minimumPeriodStart.isAfter(workPeriodStart) ? minimumPeriodStart : workPeriodStart;
//            LocalDate intersectionEnd = minimumPeriodEnd.isBefore(workPeriodEnd) ? minimumPeriodEnd : workPeriodEnd;
//            JSONObject jsonObject =  JSONObject.parseObject(new HttpHelper().doGet(url+"?begindate="+intersectionStart+"&enddate="+intersectionEnd+"&pk_psndoc="+pk_psndoc+""));
//            if(!"1".equals(jsonObject.getString("code"))) {
//            	ExceptionUtils.wrappBusinessException("ȡʧ:"+jsonObject.get("msg"));
//            }
//			return jsonObject.getJSONObject("data").getString("workday");
//        }
//	}
	

	  
	public static String DateIntersection(Date workPeriodStart, Date workPeriodEnd, Date minimumPeriodStart, Date minimumPeriodEnd, String pk_psndoc) throws Exception {  
		if (minimumPeriodEnd.compareTo(workPeriodStart) == -1) {  
	        return "0";  
		} else {  
	        Date intersectionStart = minimumPeriodStart.after(workPeriodStart) ? minimumPeriodStart : workPeriodStart;  
	        Date intersectionEnd = minimumPeriodEnd.before(workPeriodEnd) ? minimumPeriodEnd : workPeriodEnd;  
	        JSONObject jsonObject = JSONObject.parseObject(new HttpHelper().doGet(url + "?begindate=" + formatDate(intersectionStart) + "&enddate=" + formatDate(intersectionEnd) + "&pk_psndoc=" + pk_psndoc + ""));  
	        if (!"1".equals(jsonObject.getString("code"))) {  
	            ExceptionUtils.wrappBusinessException("ȡʧ:" + jsonObject.get("msg"));  
	        }  
	        return jsonObject.getJSONObject("data").getString("workday");  
	    }  
	}  
	  
	private static Date getDate(String dateStr) throws Exception {  
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
	    return sdf.parse(dateStr);  
	}  
	  
	private static String formatDate(Date date) {  
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd"); 
	    return sdf.format(date);  
	}
	
	private static String formatDates(Date date) {  
	    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM"); 
	    return sdf.format(date);  
	}
	
}
