package nc.vo.th.baod.entity;

import nc.vo.pubapp.pattern.model.entity.bill.AbstractBill;
import nc.vo.pubapp.pattern.model.meta.entity.bill.BillMetaFactory;
import nc.vo.pubapp.pattern.model.meta.entity.bill.IBillMeta;

@nc.vo.annotation.AggVoInfo(parentVO = "nc.vo.th.baod.entity.BaodHeaderVO")
public class AggBaodVO extends AbstractBill {

  @Override
  public IBillMeta getMetaData() {
    IBillMeta billMeta =BillMetaFactory.getInstance().getBillMeta(AggBaodVOMeta.class);
    return billMeta;
  }

  @Override
  public BaodHeaderVO getParentVO() {
    return (BaodHeaderVO) this.getParent();
  }
}